// BODỸXe[^XA[֘A̒`

#include <stdlib.h>
#include "BODY_Handler.h"

// BODYNX̃[m
void BODY_Handler::New_body(BODY *Body,int TypeNum[])
{
	int flag=0;

	// GeBeBVɒǉꍇ͈ȉɐVmallocLqĂB
	// GeBeB^Cv̔ԍႢɋLq
	if(TypeNum[_CIRCLE_ARC]){
		if((Body->CirA = (CIRA *)malloc(sizeof(CIRA)*TypeNum[_CIRCLE_ARC])) == NULL)  goto EXIT;
		flag = _CIRCLE_ARC+1;
	}

	if(TypeNum[_COMPOSITE_CURVE]){
		if((Body->CompC = (COMPC *)malloc(sizeof(COMPC)*TypeNum[_COMPOSITE_CURVE])) == NULL)  goto EXIT;
		flag = _COMPOSITE_CURVE+1;
	}

	if(TypeNum[_CONIC_ARC]){
		if((Body->ConA = (CONA *)malloc(sizeof(CONA)*TypeNum[_CONIC_ARC])) == NULL)  goto EXIT;
		flag = _CONIC_ARC+1;
	}

	if(TypeNum[_LINE]){
		if((Body->Line = (LINE_ *)malloc(sizeof(LINE_)*TypeNum[_LINE])) == NULL)  goto EXIT;
		flag = _LINE+1;
	}

	if(TypeNum[_TRANSFORMATION_MATRIX]){
		if((Body->TMat = (TMAT *)malloc(sizeof(TMAT)*TypeNum[_TRANSFORMATION_MATRIX])) == NULL)  goto EXIT;
		flag = _TRANSFORMATION_MATRIX+1;
	}

	if(TypeNum[_NURBSC]){
		if((Body->NurbsC = (NURBSC *)malloc(sizeof(NURBSC)*TypeNum[_NURBSC])) == NULL)  goto EXIT;
		flag = _NURBSC+1;
	}

	if(TypeNum[_NURBSS]){
		if((Body->NurbsS = (NURBSS *)malloc(sizeof(NURBSS)*TypeNum[_NURBSS])) == NULL)  goto EXIT;
		flag = _NURBSS+1;
	}

	if(TypeNum[_CURVE_ON_PARAMETRIC_SURFACE]){
		if((Body->ConpS = (CONPS *)malloc(sizeof(CONPS)*TypeNum[_CURVE_ON_PARAMETRIC_SURFACE])) == NULL)  goto EXIT;
		flag = _CURVE_ON_PARAMETRIC_SURFACE+1;
	}

	if(TypeNum[_TRIMMED_SURFACE]){
		if((Body->TrmS = (TRMS *)malloc(sizeof(TRMS)*TypeNum[_TRIMMED_SURFACE])) == NULL)  goto EXIT;
		flag = _TRIMMED_SURFACE+1;
	}

	return;		// [𐳏Ɋm


EXIT:	// [mۂɎsꍇ́A܂ŊmۂďI
	SetMessage("KOD_ERROR: malloc BODY");
	while(flag){
		if(flag == _CURVE_ON_PARAMETRIC_SURFACE+1 && TypeNum[_TRIMMED_SURFACE]){
			free(Body->ConpS);
		}
		else if(flag == _NURBSS+1 && TypeNum[_NURBSS]){
			free(Body->NurbsS);
		}
		else if(flag == _NURBSC+1 && TypeNum[_NURBSC]){
			free(Body->NurbsC);
		}
		else if(flag == _TRANSFORMATION_MATRIX+1 && TypeNum[_TRANSFORMATION_MATRIX]){
			free(Body->TMat);
		}
		else if(flag == _LINE+1 && TypeNum[_LINE]){
			free(Body->Line);
		}
		else if(flag == _CONIC_ARC+1 && TypeNum[_CONIC_ARC]){
			free(Body->ConA);
		}
		else if(flag == _COMPOSITE_CURVE+1 && TypeNum[_COMPOSITE_CURVE]){
			free(Body->CompC);
		}
		else if(flag == _CIRCLE_ARC+1 && TypeNum[_CIRCLE_ARC]){
			free(Body->CirA);
		}
		flag--;
	}
	exit(KOD_ERR);
}

// BODY\SGeBeB̃J
// TypeCount[ALL_ENTITY_TYPE_NUM]:eGeBeB̐i[ꂽ
void BODY_Handler::Free_body(BODY *Body,int TypeCount[])
{
	// GeBeBVɒǉꍇ͈ȉɐVfreeǉ
	if(TypeCount[_TRIMMED_SURFACE]){
		NFunc.Free_TrmS_1DArray(Body->TrmS,TypeCount[_TRIMMED_SURFACE]);
		free(Body->TrmS);
	}
	if(TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]){
		free(Body->ConpS);
	}
	if(TypeCount[_NURBSS]){
		NFunc.Free_NurbsS_1DArray(Body->NurbsS,TypeCount[_NURBSS]);
		free(Body->NurbsS);
	}
	if(TypeCount[_NURBSC]){
		NFunc.Free_NurbsC_1DArray(Body->NurbsC,TypeCount[_NURBSC]);
		free(Body->NurbsC);
	}
	if(TypeCount[_TRANSFORMATION_MATRIX]){
		free(Body->TMat);
	}
	if(TypeCount[_LINE]){
		free(Body->Line);
	}
	if(TypeCount[_CONIC_ARC]){
		free(Body->ConA);
	}
	if(TypeCount[_COMPOSITE_CURVE]){
		NFunc.Free_CompC_1DArray(Body->CompC,TypeCount[_COMPOSITE_CURVE]);
		free(Body->CompC);
	}
	if(TypeCount[_CIRCLE_ARC]){
		free(Body->CirA);
	}
}



// ̐F̏l^
void BODY_Handler::InitCurveColor(float *col)
{
	col[0] = col[1] = col[2] = 1.0;
	col[3] = 0.5;
}

// ʂ̐F̏l^
void BODY_Handler::InitSurfaceColor(float *col)
{
	col[0] = col[1] = col[2] = 0.2;
	col[3] = 0.5;
}


// GeBeB̃Xe[^XŒ`ĂFύX
void BODY_Handler::ChangeStatColor(float *col,float r,float g,float b,float t)
{
	col[0] = r;
	col[1] = g;
	col[2] = b;
	col[3] = t;
}

// ZNVĂBODYԍ𓾂
BODY *BODY_Handler::SearchBodyList(BODYList *BodyList,int key)
{
	return (BODY *)BodyList->getData(key);
}

// BODY
void BODY_Handler::Init_body(BODY *body)
{
	body->MaxCoord = 1.0;

	for(int i=0;i<ALL_ENTITY_TYPE_NUM;i++){
		body->TypeNum[i] = 0;
	}
}

// 1NURBSȐVBODYƂēo^
void BODY_Handler::RegistNurbsCtoBody(BODYList *BodyList,BODY *Body,NURBSC Nurb,char BodyName[])
{
	Init_body(Body);	
	Body->NurbsC = (NURBSC *)malloc(sizeof(NURBSC));
	Body->NurbsC[0] = Nurb;												// NURBSȖʂ̎̂
	Body->TypeNum[_NURBSC] = 1;											// NURBSȖʂ̐1ɂ
	ChangeStatColor(Body->NurbsC[0].Dstat.Color,0.2,0.2,1.0,0.5);		// F
	BodyList->add((void *)Body);										// XgɐVBODYo^
	SetBodyNameToWin(BodyName);											// BodyXgEBhEBODYo^
	strcpy(Body->Name,BodyName);										// VBODYo^
}

// NNURBSȐVBODYƂēo^
void BODY_Handler::RegistNurbsCtoBodyN(BODYList *BodyList,BODY *Body,NURBSC Nurb[],char BodyName[],int N)
{
	Init_body(Body);	
	Body->NurbsC = (NURBSC *)malloc(sizeof(NURBSC)*N);
	for(int i=0;i<N;i++){
		Body->NurbsC[i] = Nurb[i];										// NURBSȖʂ̎̂
		Body->TypeNum[_NURBSC] = N;										// NURBSȖʂ̐1ɂ
		ChangeStatColor(Body->NurbsC[i].Dstat.Color,0.2,0.2,1.0,0.5);	// F
	}
	BodyList->add((void *)Body);										// XgɐVBODYo^
	SetBodyNameToWin(BodyName);											// BodyXgEBhEBODYo^
	strcpy(Body->Name,BodyName);										// VBODYo^
}


// 1NURBSȖʂVBODYƂēo^
void BODY_Handler::RegistNurbsStoBody(BODYList *BodyList,BODY *Body,NURBSS Nurb,char BodyName[])
{
	Init_body(Body);	
	Body->NurbsS = (NURBSS *)malloc(sizeof(NURBSS));
	Body->NurbsS[0] = Nurb;												// NURBSȖʂ̎̂
	Body->NurbsS[0].TrmdSurfFlag = KOD_FALSE;							// ĝȂPNURBSȖʂł邱Ƃ𖾎
	Body->TypeNum[_NURBSS] = 1;											// NURBSȖʂ̐1ɂ
	ChangeStatColor(Body->NurbsS[0].Dstat.Color,0.2,0.2,1.0,0.5);		// F
	BodyList->add((void *)Body);										// XgɐVBODYo^
	SetBodyNameToWin(BodyName);											// BodyXgEBhEBODYo^
	strcpy(Body->Name,BodyName);										// VBODYo^
}

// NNURBSȖʂVBODYƂēo^
void BODY_Handler::RegistNurbsStoBodyN(BODYList *BodyList,BODY *Body,NURBSS Nurb[],char BodyName[],int N)
{
	Init_body(Body);	
	Body->NurbsS = (NURBSS *)malloc(sizeof(NURBSS)*N);
	for(int i=0;i<N;i++){
		Body->NurbsS[i] = Nurb[i];										// NURBSȖʂ̎̂
		Body->NurbsS[i].TrmdSurfFlag = KOD_FALSE;						// ĝȂPNURBSȖʂł邱Ƃ𖾎
		Body->TypeNum[_NURBSS] = N;										// NURBSȖʂ̐1ɂ
		ChangeStatColor(Body->NurbsS[i].Dstat.Color,0.2,0.2,1.0,0.5);	// F
	}
	BodyList->add((void *)Body);										// XgɐVBODYo^
	SetBodyNameToWin(BodyName);											// BodyXgEBhEBODYo^
	strcpy(Body->Name,BodyName);										// VBODYo^
}

// BODỶ]
void BODY_Handler::RotBody(BODY *Body,Coord Axis,double deg)
{
	for(int i=0;i<Body->TypeNum[_NURBSS];i++)			// NURBSȖʂ̃Vtg
		NFunc.RotNurbsS(&Body->NurbsS[i],Axis,deg);
	for(int i=0;i<Body->TypeNum[_NURBSC];i++){			// NURBSȐ̃Vtg
		if(Body->NurbsC[i].EntUseFlag == GEOMTRYELEM)	// NURBSȖʂ̃pgbNvfƂĂNURBSȐɊւĂ͉Ȃ
			NFunc.RotNurbsC(&Body->NurbsC[i],Axis,deg);
	}
}

// BODỸVtg
void BODY_Handler::ShiftBody(BODY *Body,Coord d)
{
	for(int i=0;i<Body->TypeNum[_NURBSS];i++)			// NURBSȖʂ̃Vtg
		NFunc.ShiftNurbsS(&Body->NurbsS[i],d);
	for(int i=0;i<Body->TypeNum[_NURBSC];i++){			// NURBSȐ̃Vtg
		if(Body->NurbsC[i].EntUseFlag == GEOMTRYELEM)	// NURBSȖʂ̃pgbNvfƂĂNURBSȐɊւĂ͉Ȃ
			NFunc.ShiftNurbsC(&Body->NurbsC[i],d);
	}
}

