// BODY̒`

#ifndef _BODY_H_
#define _BODY_H_

#include "StdAfx.h"
#include "KodListFunc.h"

#define ALL_ENTITY_TYPE_NUM	20		// SGeBeB^Cv̐
#define CTLPNUMMAX  512		// NURBSŗpRg[|Cg̐̏
#define KNOTNUMMAX  512		// NURBSŗpmbgV[PX̐̏
#define GEOMTRYELEM 0		// IGESfBNg"Entity Use Flag"A􉽗vf
#define PARAMETRICELEM 5	// IGESfBNg"Entity Use Flag"A2DpgbNvf
#define NORM_KNOT_VAL	1	// mbgxNg𐳋KƂ͈̔͂̍ől
#define MIN_KNOT_RANGE	0.0002	// ׂ荇mbgxNg̍̒lȏł邱

typedef KODlistData BODYList;	// ėpf[^Xǧ^BODYListƂčēo^
typedef KODlistData OBJECTList;	// ėpf[^Xǧ^OBJECTListƂčēo^

// GeBeB^CṽV{`
#define	CIRCLE_ARC					100		// ~/~
#define	COMPOSITE_CURVE				102		// Ȑ
#define	CONIC_ARC					104		// ~Ȑ
#define	COPIOUS_DATA				106		// Lӓ_
#define	PLANE						108		// 
#define	LINE						110		// 
#define	PARAMETRIC_SPLINE_CURVE		112		// pgbNXvCȐ
#define	PARAMETRIC_SPLINE_SURFACE	114		// pgbNXvCȖ
#define	POINT						116		// _
#define	TRANSFORMATION_MATRIX		124		// ϊs
#define	NURBS_CURVE					126		// NURBSȐ
#define	NURBS_SURFACE				128		// NURBSȖ
#define	CURVE_ON_PARAMETRIC_SURFACE 142		// ʏ
#define	TRIMMED_SURFACE				144		// g
#define	SUBFIGURE_DEFINITION		308		// q}̒`
#define	ASSOCIATIVITY_INSTANCE		402		// O[v
#define	DRAWING						404		// }
#define	PROPERTY					406		// }ʃTCY
#define	SINGULAR_SUBFIGURE_INSTANCE 408		// q}̎Q
#define	VIEW						410		// ۖ

// GeBeB^CṽV{enumŒ`
enum EntityType{
	_CIRCLE_ARC,					// ~E~
	_COMPOSITE_CURVE,				// Ȑ
	_CONIC_ARC,						// ~Ȑ
	_COPIOUS_DATA,					// Lӓ_
	_PLANE,							// 
	_LINE,							// 
	_PARAMETRIC_SPLINE_CURVE,		// pgbNXvCȐ
	_PARAMETRIC_SPLINE_SURFACE,		// pgbNXvCȖ
	_POINT,							// _
	_TRANSFORMATION_MATRIX,			// ϊs
	_NURBSC,						// LBXvCȐ
	_NURBSS,						// LBXvCȖ
	_CURVE_ON_PARAMETRIC_SURFACE,	// ʏ
	_TRIMMED_SURFACE,				// g
	_SUBFIGURE_DEFINITION,			// q}̒`
	_ASSOCIATIVITY_INSTANCE,		// O[v
	_DRAWING,						// }
	_PROPERTY,						// }ʃTCY
	_SINGULAR_SUBFIGURE_INSTANCE,	// q}̎Q
	_VIEW							// ۖ
};

/*
 * GeBeB^CvƂɍ\̂`
 * 9̃GeBeB^CvǂݍݑΏۂƂ(ȊO͓ǂݎ̂)
 * ǉꍇ́AȉɒǉGeBeB^Cv̍\̂`Ă
 */

// ~E~
typedef struct{
	double zt;		// Z̐[
	Coord  cp[3];	// ~E~ʂ̒S_An_AI_
	double R;		// a
	double t[2];	// t[0]:n_̊px t[1]:I_̊px
	int EntUseFlag; // fBNg Entity Use Flag ̒l(0:􉽗vf 5:2DpgbNvf)
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}CIRA;

// ~Ȑ
typedef struct{
	double prop[6];	// W
	double zt;		// ZTʂ̒`
	Coord  cp[2];	// n_AI_
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}CONA;

// 
typedef struct{
	Coord cp[2];	// n_AI_
	int EntUseFlag; // fBNg Entity Use Flag ̒l(0:􉽗vf 5:2DpgbNvf)
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}LINE_;

// ϊ}gbNX
typedef struct{
	double R[3][3];	// ]s
	double T[3];	// ixNg
	int pD;			// fBNgւ̋t|C^
}TMAT;

// LBXvC(NURBS)Ȑ
typedef struct{
	int K;			// Rg[|Cg̐
	int M;			// K(=+1)
	int N;			// mbgxNg̐
	int prop[4];	// evpeB								// prop[0]==0:񕽖ʓȐ, 1:ʓȐ
	double *T;		// mbgV[PX̒l K+M				// prop[1]==0:ȐłȂC1:Ȑ
	double *W;		// Weight̒l K							// prop[2]==0:LC1:
	Coord *cp;		// Rg[|Cg K					// prop[3]==0:IȐ, 1:IȐ				
	double V[2];	// p[^͈̔
	Coord norm;		// @xNg
	int EntUseFlag; // fBNg Entity Use Flag ̒l(0:􉽗vf 5:2DpgbNvf)
	int pD;			// fBNgւ̋t|C^
	DispStat Dstat;	// \iFr,g,bj
}NURBSC;

// LBXvC(NURBS)Ȗ
typedef struct{
	int K[2];		// Rg[|Cg̐(u,v)
	int M[2];		// K(=+1)
	int N[2];		// mbgxNg̐
	int prop[5];	// p[^								// prop[0]==0:uŕĂ, 1:ĂȂ
	double *S;		// umbgxNg̒l A+1			// prop[1]==0:vŕĂC1:ĂȂ
	double *T;		// vmbgxNg̒l B+1			// prop[2]==0:LC1:
	double **W;		// Weight̒l								// prop[3]==0:uŔI, 1:I
	Coord  **cp;	// Rg[|Cg C					// prop[4]==0:vŔI, 1:I
	double U[2];	// up[^͈̔
	double V[2];	// vp[^͈̔
	int pD;			// fBNgւ̋t|C^
	int TrmdSurfFlag;// NURBSȖʂgʂƂČĂ΂Ă̂AƗđ݂̂tO(g:KOD_TRUE  Ɨ:KOD_FALSE)
	DispStat Dstat;	// \iFr,g,b,j
}NURBSS;

// Ȑ\łȐQp̂Ő錾
typedef union{
	CIRA CirA;		// ~E~
	CONA ConA;		// ~Ȑ
	LINE_ Line;		// 
	NURBSC NurbsC;	// NURBSȐ
}COMPELEM;

// Ȑ
typedef struct{
	int N;			// \vf
	int *DEType;	// e\vf̃GeBeB^Cv
	COMPELEM **pDE;	// e\vf̍\̂ւ̃|C^
	int DegeFlag;	// Ȑkނ2DpgbNȐ\tO
	NURBSC DegeNurbs;// Ȑkނ2DpgbNȐꍇɏkނ邽߂NURBSȐ
	int pD;			// fBNgւ̋t|C^
}COMPC;

// ʏ\łȐQp̂Ő錾
typedef union{
	CIRA  CirA;		// ~E~
	COMPC CompC;	// Ȑ
	CONA  ConA;		// ~Ȑ
	NURBSC NurbsC;	// NURBSȐ
}CURVE;

// ʏ
typedef struct{
	int crtn;		// ʏǂ̂悤ɍꂽ
	int SType;		// Surface S̃GeBeB^Cv
	int BType;		// Curve B̃GeBeB^Cv
	int CType;		// Curve C̃GeBeB^Cv
	NURBSS *pS;		// CurveSurface\̂ւ̃|C^
	CURVE *pB;		// Surface S̃p[^ԂɂCurve B\̂ւ̃|C^
	CURVE *pC;		// Curve C\̂ւ̃|C^
	int pref;		// 葤VXeō̂Ă\tO
	int pD;			// fBNgւ̋t|C^
}CONPS;

// g
typedef struct{
	NURBSS *pts;	// gSurface EntityDEւ̃|C^
	int n1;			// 0:OD̋EƈvA1:ȊO
	int n2;			// Trimmed Surface̓ɂPȐ̐
	CONPS *pTO;		// Trimmed Surface̊OɂPȐ\̂ւ̃|C^
	CONPS **pTI;	// Trimmed Surface̓ɂPȐ\̂ւ̃|C^
	int pD;			// fBNgւ̋t|C^
}TRMS;

typedef TRMS TRIMD_NURBSS;	// gʂɑ΂NurbsȖʂzN閼̂^Ă

// ZNVꂽGeBeB̏\
typedef struct{
	int Body;		// BODYIuWFNg̔ԍ
	int Type;		// GeBeB^CṽV{(NURBSȐ:126 , NURBSȖ:128 , g:144)
	int Num;		// Typeɂvfԍ(NURBSȐ4{A4{Ɋ蓖Ăꂽ0`3̔ԍ)
	int CCount;		// ԖڂɃsbNꂽȐ\
	int SCount;		// ԖڂɃsbNꂽȖʂ\
}OBJECT;

// SẴGeBeB𓝊BODY\
typedef struct{
	CIRA  *CirA;		// ~E~
	COMPC *CompC;		// Ȑ
	CONA  *ConA;		// ~Ȑ
	LINE_ *Line;		// 
	TMAT  *TMat;		// ϊs
	NURBSC *NurbsC;		// NRBSȐ
	NURBSS *NurbsS;		// NRBSȖ
	CONPS *ConpS;		// ʏ
	TRMS  *TrmS;		// g
	double MaxCoord;	// ̂̐@̍ől(̒lŏ\{)
	int  TypeNum[ALL_ENTITY_TYPE_NUM];	// BODY\eGeBeB̐i[z
	char Name[FNAMEMAX];	// BODY
}BODY;


#endif
