// KodatunoCNX
// BODY`AC^[tF[X`

#include "Kodatuno.h"

// KodatunotH[̏
void KODatUNO::InitializeWin()
{

	SetMessage("Welcome to Kodatuno!");			// R\[
	WSCstring mes = Console_Form->getString();
	SetConsoleCharNum(mes.getChars());			// ݂̃R\[ۑ

	ScreenWidth = Describe_Form->getProperty(WSNwidth);		// `EBhE̕擾
	ScreenHeight = Describe_Form->getProperty(WSNheight);	// `EBhE̍擾

	// R\[R}ho^
	SetCmdList(CmdMap,"verinf","fF",0,CmdVerInf);			// Command o[Wo
	SetCmdList(CmdMap,"open","N",1,CmdFileOpen);			// Command t@CI[v_CAOI[v
	SetCmdList(CmdMap,"wire","",2,CmdUVWire);				// Command BodyC[t[\ɂ
	SetCmdList(CmdMap,"scale","r",3,CmdChScale);			// Command XP[̊mFyѕύX
	SetCmdList(CmdMap,"rots","",4,CmdGenRotSurf);			// Command ]T[tFX𐶐
	SetCmdList(CmdMap,"sweeps","",5,CmdGenSweepSurf);		// Command XC[vT[tFX𐶐
	SetCmdList(CmdMap,"nurbsc","",6,CmdGenNurbsCurve);		// Command ^ꂽ_QNURBSȐ𐶐
	SetCmdList(CmdMap,"nurbss","",7,CmdGenNurbsSurface);	// Command ^ꂽ_QNURBSȖʂ𐶐
	SetCmdList(CmdMap,"tol","r",8,CmdChTolerance);			// Commnad ʕ`̃gXl̊mFyѕύX
	SetCmdList(CmdMap,"move","r",9,CmdMoveBody);			// Commnad IĂBodyw肵ړʂsړ
	SetCmdList(CmdMap,"rot","r",10,CmdRotateBody);			// Command IĂBodyw肵pxsړ
	SetCmdList(CmdMap,"cpview","",11,CmdCPView);			// Command Rg[|Cg`
	SetCmdList(CmdMap,"surfinfo","",12,CmdSurfInfo);		// Command Ȗʏo
	SetCmdList(CmdMap,"exp","r",13,CmdExpand);				// Command Bodyg傷
	SetCmdList(CmdMap,"chrank","r",14,CmdChRank);			// Command w肵NURBSȖʂRankύX

	// UserR}h̓o^
	User.RegistUserCommand(CmdMap);

	User.SetMenuLabelName();	// Userj[o^
	User_Func_Btn1->setProperty(WSNlabelString,User.GetMenuLabelName(0));	// {^xɔf
	User_Func_Btn2->setProperty(WSNlabelString,User.GetMenuLabelName(1));
	User_Func_Btn3->setProperty(WSNlabelString,User.GetMenuLabelName(2));
	User_Func_Btn4->setProperty(WSNlabelString,User.GetMenuLabelName(3));
	User_Func_Btn5->setProperty(WSNlabelString,User.GetMenuLabelName(4));

	// ̑
	Focus_Body = KOD_ERR;
	OpenGLInitFlag = KOD_FALSE;
	LBtnFlag = KOD_FALSE;
	RBtnFlag = KOD_FALSE;
	MBtnFlag = KOD_FALSE;
	ShiftKeyFlag = KOD_FALSE;
	CtrlKeyFlag = KOD_FALSE;
	AltKeyFlag = KOD_FALSE;
	SweepSelectFlag = KOD_FALSE;
	SolidViewFlag = KOD_TRUE;
	EdgeViewFlag = KOD_TRUE;
	WireFlameViewFlag = KOD_FALSE;
	BlendViewFlag = KOD_FALSE;
	CPViewFlag = KOD_FALSE;
	InitCmdFlags();
	CmdStackNum = 0;
	CmdStackNow = 0;
	StartX = 0;
	StartY = 0;
	OldPosX = 0;
	OldPosY = 0;
	CurrentX = 0;
	CurrentY = 0;
	AxisScale = 0.2;
	ModelScale = 1;
	ModelScale1st = 1;
	StartQ = QFunc.QInit(1.0,0,0,0);
	TargetQ = QFunc.QInit(1.0,0,0,0);
	QFunc.QtoR(RotMx,StartQ);
	Vp[0] = Vp[1] = Vp[2] = Vp[3] = 0;
	Trl[0] = Trl[1] = Trl[2] = 0.0;
	DrawBODYFlag = KOD_FALSE;
	DrawSurfFlag = KOD_TRUE;
	ReDrawBODYFlag = KOD_FALSE;
	for(int i=0;i<USERFUNCNUMMAX;i++)
		ExecUserFuncFlag[i] = KOD_FALSE;
	for(int i=0;i<USERCOMMANDNUM;i++)
		ExecUserCommandFlag[i] = KOD_FALSE;
	DoSelectFlag = KOD_FALSE;
	Tolerance = TOLERANCE;

	glGenLists(USERFUNCNUMMAX+1);

}

// KodatunotH[̏I
void KODatUNO::DeleteWin()
{
	int bodynum = BodyList.getNum();				// ǂݍBODY̐𓾂

	for(int i=0;i<bodynum;i++){
		BODY *body = (BODY *)BodyList.getData(i);	// iԖڂBODYI
		Free_body(body,body->TypeNum);				// BODYŊmۂĂ郁[̉
		delete (BODY *)body;						// BODYg̃[
	}
	BodyList.clear();		// BODYXgg

	exit(0);
}

// OpenGL`̈̍ĕ`掞Ɏs(OpenGLpӂAPI͂̊֐ɂԂ牺ĂȂ΂ȂȂ)
void KODatUNO::ReDraw(int x,int y)
{
	SetOpenGLStat();				// `Xe[^X̐ݒ

	// ZNVgK
	if(DoSelectFlag == KOD_TRUE){
		DoSelect(x,y);				// ZNVs
		DoSelectFlag = KOD_FALSE;	// ZNVgKOFF
		ReDrawBODYFlag = KOD_FALSE;	// ĕ`
	}

	// \ؑ
	if(BlendViewFlag == KOD_TRUE){
		glDepthMask(GL_FALSE);
		glDisable(GL_BLEND); 
		Describe_Main();				// BODY`
		glDepthMask(GL_TRUE);
		glEnable(GL_BLEND);  
		Describe_Main();				// BODY`
	}
	else{
		glDepthMask(GL_TRUE);
		glDisable(GL_BLEND); 
		Describe_Main();				// BODY`
	}

	// XC[vZNVtOONȂ`
	if(SweepSelectFlag == KOD_TRUE){
		glMatrixMode(GL_PROJECTION);				// eϊsX^bNI
		glPushMatrix();								// ݂̍Wnۑ
		glLoadIdentity();							// eϊsX^bN̐擪ɒPʍs}
		gluOrtho2D(0,ScreenWidth,ScreenHeight,0); 	// _ݒ(o[oh𐳂ʒuɕ\邽)

		glMatrixMode(GL_MODELVIEW);					// fr[s
		glPushMatrix();								// ݂̍Wnۑ
		glLoadIdentity();							// fr[s̐擪ɒPʍs}
		
		DrawRubberband(StartX,StartY,CurrentX,CurrentY);		// o[oh`

		// Wnɖ߂
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();
	}

	// R}hsɂ`
	if(UVWireFlameViewFlag == KOD_TRUE)				// C[t[̏ڍו`
		UVWireView();
	if(CPViewFlag == KOD_TRUE)						// Rg[|Cg̕`
		DescribeCP();



}

// BODY`惁C
void KODatUNO::Describe_Main()
{
	if(DrawBODYFlag != KOD_TRUE) return;

	// BODY`tOONȂ`
	if(ReDrawBODYFlag == KOD_FALSE){							// ԏ̂݃fBXvCXgBODYo^
		SetNurbsSTolerance(Tolerance);							// ĕ`扉Zw߂󂯂ꍇÃ݂fXP[ɍNurbsgXw
		glNewList(COMMAND_DRAW_BODY,GL_COMPILE_AND_EXECUTE);	// glDrawBODY()R}hƂă[ɕۑ(ZNV̍)
		DrawBODY();												// IGESf[^`
		glEndList();
		ReDrawBODYFlag = KOD_TRUE;
	}
	else{
		glCallList(COMMAND_DRAW_BODY);			// 2ڈȍ~̕`Ăяo̓fBXvCXgĂяo
	}
}

// IGESf[^̕`
void KODatUNO::DrawBODY()
{
	int i;
	BODY *body;

	// body`
	for(int k=0;k<BodyList.getNum();k++){					// ݃Xgɓo^ĂBODY̐[v
		if((body = (BODY *)BodyList.getData(k)) != NULL){	// kԖڂ̃Xgɓo^ĂBODỸf[^擾
			glPushName(k);									// ZNVobt@Kw
			// e^CvƂɕ`sĂ(\NURBSɌ肵̂ŁA~Ȃǂ͕`悵Ȃ)
			for(i=0;i<ALL_ENTITY_TYPE_NUM;i++){
				if(i == _CIRCLE_ARC){						// ~E~
					// ~E~ʂNRBSȐɕϊ
					//glPushName(_CIRCLE_ARC);				// ZNVobt@Kw
					//Draw_CircleArc();
					//glPopName();
				}
				else if(i == _CONIC_ARC){					// ~Ȑ
					//glPushName(_CONIC_ARC);				// ZNVobt@Kw
					//Draw_ConicArc();
					//glPopName();
				}
				else if(i == _LINE){						// 
					// NURBSȐɕϊ
					//glPushName(_LINE);					// ZNVobt@Kw
					//Draw_Line();
					//glPopName();
				}
				else if(i == _NURBSC){						// NURBSȐ
					if(EdgeViewFlag == KOD_TRUE){			// Edge\/\؂ւ
					glPushName(_NURBSC);					// ZNVobt@Kw
					Draw_NurbsCurve(body);
					glPopName();
					}
				}
				else if(i == _NURBSS){
					glPushName(_NURBSS);
					Draw_NurbsSurface(body);
					glPopName();
				}
				else if(i == _TRIMMED_SURFACE){				// g(NURBSȖ)
					glPushName(_TRIMMED_SURFACE);
					Draw_TrimSurfe(body);
					glPopName();
				}
			}
			glPopName();
		}
	}
}


// NURBSȐ̕`
void KODatUNO::Draw_NurbsCurve(BODY *Curr_body)
{
	for(int i=0;i<Curr_body->TypeNum[_NURBSC];i++){
		glPushName(i);		// l[X^bN̐擪i}
		glColor3f(Curr_body->NurbsC[i].Dstat.Color[0],Curr_body->NurbsC[i].Dstat.Color[1],Curr_body->NurbsC[i].Dstat.Color[2]);
		if(Curr_body->NurbsC[i].EntUseFlag == GEOMTRYELEM){				// IGESfBNg"Entity Use Flag"0̏ꍇ͎ۂ̃fvfƂĕ`悷
			DrawNurbsCurve(Curr_body->NurbsC[i]);						// `
		}
		glPopName();		// l[X^bN̐擪폜
	}
}

// NURBSȖʂ̕`
void KODatUNO::Draw_NurbsSurface(BODY *Curr_body)
{
	for(int i=0;i<Curr_body->TypeNum[_NURBSS];i++){
		if(Curr_body->NurbsS[i].TrmdSurfFlag == KOD_TRUE)	// gʂƂNURBSȖʂo^ĂȂ
			continue;		// `悵Ȃ
		else{
			glPushName(i);
			DrawNurbsSurfe(Curr_body->NurbsS[i]);	// NURBSȖʕ`
			glPopName();
		}
	}
}


// gʂ̕`
void KODatUNO::Draw_TrimSurfe(BODY *Curr_body)
{
	for(int i=0;i<Curr_body->TypeNum[_TRIMMED_SURFACE];i++){
		glPushName(i);			// l[X^bN̐擪i}
		DrawTrimdSurf(Curr_body->TrmS[i]);
		glPopName();			// l[X^bN̐擪폜
	}
}

// `
void KODatUNO::DrawAxis(double Ascale,double Mscale)
{
	GLdouble AxisPos = Ascale/Mscale;
	GLdouble CharPos = (Ascale+0.01)/Mscale;

	glDisable(GL_LIGHTING);

	glLineWidth(1);
	glBegin(GL_LINES);
	//draw Xaxis@
	glColor3f(1.0, 0.0, 0.0);
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(AxisPos, 0.0, 0.0);

	//draw Yaxis@
	glColor3f(0.0, 1.0, 0.0 );
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(0.0, AxisPos, 0.0);

	//draw Zaxis@
	glColor3f(0.0, 0.0, 1.0);
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(0.0, 0.0, AxisPos);
	glEnd();

	/* Draw Xcone */
	glColor3f(1.0, 0.0, 0.0);
	glPushMatrix();
	glTranslatef(AxisPos, 0.0, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glutSolidCone(AxisPos*0.1,AxisPos*0.5,4,1);
	glPopMatrix();

	/* Draw Ycone */
	glColor3f(0.0, 1.0, 0.0);
	glPushMatrix();
	glTranslatef(0.0, AxisPos, 0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glutSolidCone(AxisPos*0.1,AxisPos*0.5,4,1);
	glPopMatrix();

	/* Draw Zcone */
	glColor3f(0.0, 0.0, 1.0);
	glPushMatrix();
	glTranslatef(0.0, 0.0, AxisPos);
	glutSolidCone(AxisPos*0.1,AxisPos*0.5,4,1);
	glPopMatrix();

	//  X
	glColor3d(1.0,0.0,0.0);
	glRasterPos3d(CharPos,0.0,0.0);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10,'X');

	//  Y
	glColor3d(0.0,1.0,0.0);
	glRasterPos3d(0.0,CharPos,0.0);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10,'Y');

	//  Z
	glColor3d(0.0,0.0,1.0);
	glRasterPos3d(0.0,0.0,CharPos);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10,'Z');

	glEnable(GL_LIGHTING);
}

// o[oh`
void KODatUNO::DrawRubberband(double sx,double sy,double ex,double ey)
{
	glDisable(GL_LIGHTING);
	glLineWidth(1);
	glLineStipple(1, 0xE0E0);
	glColor3f(0.2, 0.9, 0.9);
	glEnable(GL_LINE_STIPPLE);
	glBegin(GL_LINE_STRIP);
	glVertex2d(sx,sy);
	glVertex2d(ex,sy);
	glVertex2d(ex,ey);
	glVertex2d(sx,ey);
	glVertex2d(sx,sy);
	glEnd();
	glDisable(GL_LINE_STIPPLE);
	glEnable(GL_LIGHTING);
}

// R\[ۑ
void KODatUNO::SetConsoleCharNum(int len)
{
	ConsoleCharNum = len;
}

// R\[o
int KODatUNO::GetConsoleCharNum()
{
	return ConsoleCharNum;
}

// 3Df[^t@C̓ǂݍ
int KODatUNO::OpenFile()
{
	WSCfileSelect *fs=WSGIappFileSelect();			// t@CI_CAÕAhX擾

	fs->setProperty(WSNmaskFileName,"IGS,igs,STL,stl");		// IGS,STLt@ĈݑI

	fs->setProperty(WSNx,300);						// _CAO\ʒu
	fs->setProperty(WSNy,320);

	long fchoice_dlg = fs->popup();					// t@CI_CAOJ

	if(fchoice_dlg == WS_DIALOG_OK){				// _CAOOK{^ꂽ
		SetMessage("Reading...");
		WSCstring full_name = fs->getFileName();		// t@C̃tpX擾
		WSCstring fname = fs->getProperty(WSNfileName);	// t@C擾
		fname.to_lower();								// t@CSďɕϊ
		Body_List_Win->addItem(fname);					// BodyXgEBhEɐVɓǂݍBODYt
		int priodnum = fname.getWords(".");				// t@CɊ܂܂ĂsIh̐𒲂ׂ
		WSCstring ext = fname.getWord(priodnum-1,".");	// gq擾

		BODY *body = new BODY;							// BODY1[m

		WSCstring ext_igs("igs");
		WSCstring ext_stl("stl");

		int flag;
		if(ext == ext_igs){				// gq"igs"
			IGES_PARSER Iges;
			flag = Iges.IGES_Parser_Main(body,full_name);			// IGESf[^ǂݍŁAbodyɊi[
			if(flag == KOD_TRUE)	Iges.ExpandKnotRange(body);		// mbgxNg̐K
			if(flag == KOD_TRUE)	Iges.CheckDegenracy(body);		// k(2DpgbNȐ̎n_ƏI_vĂ邩)̃`FbN
			if(flag == KOD_TRUE)	Iges.ModifyParamConect(body);	// pgbNʓ̃gȐm̂Ȃ`FbNAC
		}
		else if(ext == ext_stl){		// gq"stl"
			STL_PARSER Stl;
			flag = Stl.STL_Parser_Main(body,full_name);
		}
		if(flag == KOD_ERR){
			delete body;					// G[̏ꍇBODỸ[
			SetMessage("This file was not able to be read normaly.");
			return KOD_ERR;
		}
		strcpy(body->Name,fname);				// t@CbodyƂēo^
		BodyList.add((void *)body);				// Xgɓǂݍbodyo^
		SetMessage("Finished");
	}
	
	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾

	SetModelScale();						// fXP[œK

	return KOD_TRUE;
}

// 3Df[^t@C̓ǂݍ(I[o[[h)
int KODatUNO::OpenFile(char *Fname)
{
	WSCstring fname(Fname);
	fname.to_lower();							// t@CSďɕϊ
	Body_List_Win->addItem(fname);				// BodyXgEBhEɐVɓǂݍBODYt
	int priodnum = fname.getWords(".");				// t@CɊ܂܂ĂsIh̐𒲂ׂ
	WSCstring ext = fname.getWord(priodnum-1,".");	// gq擾

	BODY *body = new BODY;						// BODY1[m

	WSCstring ext_igs("igs");
	WSCstring ext_stl("stl");

	int flag;
	if(ext == ext_igs){				// gq"igs"
		IGES_PARSER Iges;
		flag = Iges.IGES_Parser_Main(body,fname);		// IGESf[^ǂݍŁAbodyɊi[
		Iges.CheckDegenracy(body);					// k(2DpgbNȐ̎n_ƏI_vĂ邩)̃`FbN
	}
	else if(ext == ext_stl){		// gq"stl"
		STL_PARSER Stl;
		flag = Stl.STL_Parser_Main(body,fname);
	}
	if(flag == KOD_ERR){
		delete body;					// G[̏ꍇBODỸ[
		SetMessage("This file was not able to be read normaly.");
		return KOD_ERR;
	}
	strcpy(body->Name,fname);				// t@CbodyƂēo^
	BodyList.add((void *)body);				// Xgɓǂݍbodyo^
	SetMessage("Finished");

	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾

	SetModelScale();						// fXP[œK

	OpenDelBtn();

	return KOD_TRUE;
}

// Cvbgt@C̓ǂݍ
int KODatUNO::OpenInpFile()
{
	WSCfileSelect *fs=WSGIappFileSelect();			// t@CI_CAÕAhX擾

	fs->setProperty(WSNmaskFileName,"INP,inp");		// inpt@ĈݑI

	long fchoice_dlg = fs->popup();					// t@CI_CAOJ

	if(fchoice_dlg == WS_DIALOG_OK){				// _CAOOK{^ꂽ
		WSCstring full_name = fs->getFileName();	// t@C̃tpX擾
		InpFileName->setProperty(WSNlabelString,full_name);	// t@C̃tpX[U[ݒ蕶ɃZbg
	}

	return KOD_TRUE;
}


// IĂBODY
void KODatUNO::DeleteBody()
{
	if(!SeldEntList.getNum() && Focus_Body == KOD_ERR)	return;			// ZNV,XgEBhEIĂȂꍇ͉Ȃ

	int buf=KOD_ERR;
	int delnum[BODYLISTMAX];
	int delcount=0;
	BODY *body;
	OBJECT *obj;


	// ZNVĂȂAXgEBhEł͑IĂꍇ
	if(!SeldEntList.getNum()){
		body = (BODY *)BodyList.getData(Focus_Body);		// XgEBhEőIĂBODYԍĂ
		DeleteBodySub(body,Focus_Body);						// BODY폜
		Focus_Body = KOD_ERR;								// XgEBhEłȂɂtH[JXĂȂԂɖ߂
	}

	// ZNVĂꍇ,
	// ZNVĂGeBeBAǂBODYIĂ邩o
	for(int i=0;i<SeldEntList.getNum();i++){
		obj = (OBJECT *)SeldEntList.getData(i);
		if(buf != obj->Body){
			buf = obj->Body;
			delnum[delcount] = obj->Body;
			delcount++;
		}
	}
	BubbleSort(delnum,delcount);

	for(int i=delcount-1;i>=0;i--){
		body = (BODY *)BodyList.getData(delnum[i]);
		DeleteBodySub(body,delnum[i]);
	}

	ClearSeldEntList();

	ReDrawBODYFlag = KOD_FALSE;		// ĕ`w
}

// IĂBODYSub
void KODatUNO::DeleteBodySub(BODY *body,int n)
{
	if (body == NULL) return;

	char mes[256];
	sprintf(mes,"%s was deleted.",body->Name);
	SetMessage(mes);

	BodyList.delPos(n);							// Xg͂
	Body_List_Win->delPos(n);					// XgEBhE͂
	Free_body(body,body->TypeNum);				// BODYŊmۂĂ郁[̉
	delete (BODY *)body;						// BODYg̃[
}

// OpenCDelete{^̕\̕ύX
void KODatUNO::OpenDelBtn()
{
    //J{^̐ݒ
    if(BodyList.getNum() == BODYLISTMAX)//t@C8JĂ
        Open_Body_Btn->setSensitive(False); //WF\iȂj
	else
        Open_Body_Btn->setSensitive(True);  //ʏ\ij
    
    //폜{^̐ݒ
    if(BodyList.getNum() == 0)//t@CȂ
        Del_Body_Btn->setSensitive(False);  //WF\iȂj
    else
        Del_Body_Btn->setSensitive(True);   //ʏ\ij
}

// {fBXgł̑I
int KODatUNO::BodyListSelect()
{
	Focus_Body = Body_List_Win->getSelectedPos();	//Iڂ̏o

	return KOD_TRUE;
}

// œKfXP[擾
void KODatUNO::SetModelScale()
{
	BODY *body;
	double max=0;

	if(!BodyList.getNum()) return;

	for(int i=0;i<BodyList.getNum();i++){
		body = (BODY *)BodyList.getData(i);
		if(max < body->MaxCoord)
			max = body->MaxCoord;
	}
	ModelScale = 1/max;						// ʂɃIuWFNgŜʂ悤ɕ`XP[𒲐
	ModelScale1st = ModelScale;				// fXP[̏loĂ
}

// BODY̍ő咷ݒ肷
void KODatUNO::SetMaxCoord()
{
	BODY *body;

	if(!BodyList.getNum()) return;

	for(int i=0;i<BodyList.getNum();i++){
		body = (BODY *)BodyList.getData(i);
		double max = 0;
		for(int j=0;j<body->TypeNum[_NURBSS];j++){
			for(int u=0;u<body->NurbsS[j].K[0];u++){
				for(int v=0;v<body->NurbsS[j].K[1];v++){
					double d = CalcEuclid(body->NurbsS[j].cp[u][v]);
					if(d > max)	max = d;
				}
			}
		}
		body->MaxCoord = max;
	}
}


// EBhẼTCY擾
void KODatUNO::GetResizeWindow()
{
	ScreenWidth = Describe_Form->getProperty(WSNwidth);		// 擾
	ScreenHeight = Describe_Form->getProperty(WSNheight);	// 擾

	glViewport(0,0,ScreenWidth,ScreenHeight);
}

// OpenGL̏
void KODatUNO::SetOpenGLStat()
{
	if(OpenGLInitFlag == KOD_FALSE){
		
		GLfloat diffuse[] = { 0.9, 0.9, 0.9, 1.0 };
		GLfloat specular[] = { 1.0, 1.0, 1.0, 1.0 };
		GLfloat ambient[] = { 1.0, 1.0, 1.0, 1.0 };
		GLfloat mat_diffuse[] = { 0.7, 0.7, 0.7, 1.0 };
		GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
		GLfloat mat_shininess[] = { 100.0 };
		GLfloat mat_ambient[] = { 0.2, 0.2, 0.2, 1.0 };

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		// ̐ݒ
		glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
		glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
		glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);

		// }eA̐ݒ
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
		glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
		glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);

		glEnable(GL_LIGHTING);
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
		glEnable(GL_LIGHT0);
		glDepthFunc(GL_LESS);
		glEnable(GL_DEPTH_TEST);
		glEnable(GL_AUTO_NORMAL);
		glEnable(GL_NORMALIZE);
		glEnable(GL_POINT_SMOOTH);
		glEnable(GL_LINE_SMOOTH);
		glEnable(GL_POLYGON_SMOOTH);

		if(SolidViewFlag == KOD_TRUE)
			SetNurbsSProperty(GLU_DISPLAY_MODE, GLU_FILL);
		else if(WireFlameViewFlag == KOD_TRUE)
			SetNurbsSProperty(GLU_DISPLAY_MODE, GLU_OUTLINE_PATCH);

		glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE); 

		// glClearColor(1,1,1,0);	// wi

		OpenGLInitFlag = KOD_TRUE;
	}

	double a=2;
	double ratio;

	glViewport(0,0,ScreenWidth,ScreenHeight);
	glMatrixMode(GL_PROJECTION);	// eϊsX^bNI
	glLoadIdentity();				// eϊsX^bN̐擪ɒPʍs}

	// seݒ(AXyNgɂăf̏c䂪ςȂ悤ɏ𕪂)
	if(ScreenWidth <= ScreenHeight){
		ratio = (double)ScreenHeight/(double)ScreenWidth;
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}
	else{
		ratio = (double)ScreenWidth/(double)ScreenHeight;
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}

	glMatrixMode(GL_MODELVIEW);						// fr[s
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();								// fr[s̐擪ɒPʍs}
	gluLookAt(0,1,0,0.0,0.0,0.0,0.0,0.0,1.0);		// _ݒ
	glScaled(ModelScale,ModelScale,ModelScale);		// fXP[ݒ
	glTranslatef(Trl[0],Trl[1],Trl[2]);				// Wn𕽍sړ
	glMultMatrixd(RotMx);							// fr[sɕύXꂽ]sĂ
	DrawAxis(AxisScale,ModelScale);					// W`

}

// }EXCxg̏
//   Trig:gK[̎	Btn:ǂ̃{^ꂽ		x,y:}EẌʒu
void KODatUNO::MouseEvent(long Trig,long Btn,short x,short y)
{
	// ENbN
	if((Trig == WSEV_MOUSE_PRESS) && (Btn & WS_MOUSE_BTN3)){
		StartX = x;
		StartY = y;
		RBtnFlag = KOD_TRUE;				// E{^hbOtOON
	}

	// ^񒆃NbN
	if((Trig == WSEV_MOUSE_PRESS) && (Btn & WS_MOUSE_BTN2)){
		MBtnFlag = KOD_TRUE;
	}

	// NbN
	if((Trig == WSEV_MOUSE_PRESS) && (Btn & WS_MOUSE_BTN1)){
		StartX = x;
		StartY = y;
		LBtnFlag = KOD_TRUE;
	}

	// {^𗣂
	else if(Trig == WSEV_MOUSE_RELEASE){
		if(LBtnFlag == KOD_TRUE){			// NbNꍇ
			DoSelectFlag = KOD_TRUE;		// IuWFNgI𔻕
		}
		StartQ = QFunc.QCopy(TargetQ);		// ݂̃NH[^jIl̏lƂ
		MBtnFlag = KOD_FALSE;				// ^񒆃{^hbOtOOFF
		RBtnFlag = KOD_FALSE;				// E{^hbOtOOFF
		LBtnFlag = KOD_FALSE;				// {^hbOtOOFF
		SweepSelectFlag = KOD_FALSE;		// XC[vZNVtOOFF
		Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w
	}	
}

// }EXړ̃Cxg
void KODatUNO::MouseMotionEvent(long Btn,short x,short y)
{
	// E{^hbO-->]
	if(Btn & WS_MOUSE_BTN3 && RBtnFlag == KOD_TRUE){
		double dx = (double)(x-StartX)/(double)ScreenWidth;
		double dy = (double)(y-StartY)/(double)ScreenHeight;
		double a = sqrt(dx*dx + dy*dy);						// }EX|C^̈ʒũhbOJnʒű
		Quat dq = QFunc.QGenRot(2*PI*a,-dy/a,0,dx/a);		// ]NH[^jI
		TargetQ = QFunc.QMult(dq, StartQ);					// ]̏lStartQdq|ĉ]
		QFunc.QtoR(RotMx, TargetQ);							// NH[^jI]̕ϊs߂
		Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w
	}

	// {^hbO-->o[oh
	if(Btn & WS_MOUSE_BTN1 && LBtnFlag == KOD_TRUE){
		SweepSelectFlag = KOD_TRUE;
		CurrentX = x;
		CurrentY = y;
		Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w
	}

	// ^񒆃{^hbO-->sړ or Ctrl+^񒆃{^hbO-->gk
	else if(Btn & WS_MOUSE_BTN2 && MBtnFlag == KOD_TRUE){
		WSDkeyboard *key = WSGIappKeyboard();					// L[{[h̃CX^X𐶐
		double dx = (double)(x-OldPosX)/(double)ScreenWidth;	// ړ擾
		double dy = (double)(y-OldPosY)/(double)ScreenHeight;
		// CtrlL[ĂȂ-->sړ
		if(!key->withCntl()){
			Trl[0] -= 5*dx/ModelScale;
			Trl[2] -= 5*dy/ModelScale;
		}
		// CtrlL[Ă-->gk
		else{
			double a = 2*sqrt(dx*dx + dy*dy);
			if(x-OldPosX > 0)	ModelScale += a*ModelScale;		// }EXE֓g
			else				ModelScale -= a*ModelScale;		// }EX֓k
			if(ModelScale < 0.0001) ModelScale = 0.0001;		// kXP[̍ŏl
		}	
		Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w
		ReDrawBODYFlag = KOD_FALSE;							// ĕ`w
	}

	OldPosX = x;
	OldPosY = y;
}



// ZNV(}EXsbLO)̐ݒ
void KODatUNO::DoSelect(int x,int y)
{
	int hits;
	double ratio;
	double a=2;

    glGetIntegerv(GL_VIEWPORT,Vp);
	glSelectBuffer(MAXSELECT, SelectBuf);	// ZNVꂽIuWFNg̏Ăobt@p
	glRenderMode(GL_SELECT);				// ZNV[hɈڍs
	glInitNames();							// IuWFNgɂ閼O(l)o^Ăl[X^bN

	glMatrixMode(GL_PROJECTION);			// ˉeϊ[h
	glPushMatrix();							// ܂ł̕ϊ}gbNXۑ
	glLoadIdentity();						// ˉeϊ}gbNX

	// ʏ̃ZNV̏ꍇ
	if(StartX == x && StartY == y){
		gluPickMatrix((GLdouble)x,(GLdouble)(Vp[3] - y),5.0,5.0,Vp);	// \̈悪}EX|C^̎͂ɂȂ悤Ɏˉeϊsݒ
	}
	// XC[vZNV̏ꍇ
	else{
		gluPickMatrix((GLdouble)((StartX+x)/2),(GLdouble)((Vp[3]*2-y-StartY)/2),fabs((double)(x-StartX)),fabs((double)(StartY-y)),Vp);	// \̈悪o[ohɂȂ悤Ɏˉeϊsݒ
	}

	if(Vp[2] <= Vp[3]){
		ratio = (double)Vp[3]/(double)Vp[2];
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}
	else{
		ratio = (double)Vp[2]/(double)Vp[3];
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}

	glMatrixMode(GL_MODELVIEW);					// fϊ[hɈڍs
	glLoadIdentity();							// fr[s̐擪ɒPʍs}
	gluLookAt(0,1,0.0,0.0,0.0,0.0,0.0,0.0,1.0);	// _ݒ
	glScaled(ModelScale,ModelScale,ModelScale);	// fXP[ݒ
	glTranslatef(Trl[0],Trl[1],Trl[2]);			// Wn𕽍sړ
	glMultMatrixd(RotMx);						// fr[sɕύXꂽ]sĂ
	if(DrawBODYFlag == KOD_TRUE)				// BODY`tOONȂ
		glCallList(COMMAND_DRAW_BODY);			// eGeBeBŊKwꂽZNVpԍ𓾂(炩ߓo^ĂR}hs)
	glMatrixMode(GL_PROJECTION);				// ˉeϊ[hɖ߂
	glPopMatrix();								// ˉeϊ}gNXɖ߂
	hits = glRenderMode(GL_RENDER);				// ZNV[hIA_O[hɖ߂

	if(StartX == x && StartY == y)				// NbNőIꍇ
		ClickPicking(SelectBuf,hits);
	else
		DragPicking(SelectBuf,hits);			// hbOőIꍇ
}

// NbNɂ}EXsbLO
void KODatUNO::ClickPicking(GLuint SelectBuf[],int hits)
{
	int objnum=0;

	objnum = ObjSelect(SelectBuf,hits);			// qbgIuWFNg̒ŃfvXl̈ԏIuWFNgI


	// ȑOɃZNgꂽ̂ăZNgꍇ̓JEgȂ
	for(int i=0;i<SeldEntList.getNum();i++){
		OBJECT *obj;
		obj = (OBJECT *)SeldEntList.getData(i);
		if(obj->Body == SelectBuf[objnum*(3+SelectBuf[0])+3] &&
			obj->Type == SelectBuf[objnum*(3+SelectBuf[0])+4] &&
			obj->Num == SelectBuf[objnum*(3+SelectBuf[0])+5]){
			hits = 0;
		}
	}
	
	// VIuWFNgɃqbgꍇ
	if(hits >= 1)
		SetNewObject(SelectBuf[objnum*(3+SelectBuf[0])+3],SelectBuf[objnum*(3+SelectBuf[0])+4],SelectBuf[objnum*(3+SelectBuf[0])+5]);
}

// hbOɂ}EXsbLO
void KODatUNO::DragPicking(GLuint SelectBuf[],int hits)
{
	int temp=0;	// ăZNgʗpJE^

	// ͈͑IɂăIuWFNgɃqbgꍇ
	for(int i=0;i<hits;i++){
		for(int j=0;j<SeldEntList.getNum();j++){
			OBJECT *obj = (OBJECT *)SeldEntList.getData(j);
			if(obj != NULL && obj->Body == SelectBuf[i*(3+SelectBuf[0])+3] &&
				obj->Type == SelectBuf[i*(3+SelectBuf[0])+4] &&
				obj->Num == SelectBuf[i*(3+SelectBuf[0])+5]){
					temp++;
			}
		}
		// IuWFNgVqbgꍇ
		if(temp == 0)
			SetNewObject(SelectBuf[i*(3+SelectBuf[0])+3],SelectBuf[i*(3+SelectBuf[0])+4],SelectBuf[i*(3+SelectBuf[0])+5]);

		temp = 0;
	}
}

// sbNꂽIuWFNgOBJECTXgɓo^
void KODatUNO::SetNewObject(int BodyNum,int TypeNum,int NumNum)
{
	OBJECT *obj = new OBJECT;
	obj->Body = BodyNum;
	obj->Type = TypeNum;
	obj->Num = NumNum;
	SeldEntList.add((void *)obj);							// ZNgꂽGeBeBXgɓo^
	BODY *body;
	body = (BODY *)BodyList.getData(obj->Body);
	if(obj->Type == _NURBSC){
		ChangeStatColor(body->NurbsC[obj->Num].Dstat.Color,1,0.2,1,0.5);	// Iς݂ߐFύX
	}
	else if(obj->Type == _TRIMMED_SURFACE || obj->Type == _NURBSS){
		ChangeStatColor(body->NurbsS[obj->Num].Dstat.Color,0.3,0.1,0.2,0.5);	// Iς݂ߐFύX
	}

}

// SăZNgԂɂ
void KODatUNO::SelectAll()
{
	BODY *body;

	for(int i=0;i<BodyList.getNum();i++){					// ݃Xgɓo^ĂBODY̐[v
		if((body = (BODY *)BodyList.getData(i)) != NULL){	// iԖڂ̃Xgɓo^ĂBODỸf[^擾
			// NURBSCIς݂ɂ鑀
			for(int j=0;j<body->TypeNum[_NURBSC];j++){
				// ݒڒ̗vfɑIς݂𔻕
				bool flag = false;
				for(int k=0;k<SeldEntList.getNum();k++){
					OBJECT *obj_ = (OBJECT *)SeldEntList.getData(k);
					if(obj_ != NULL && obj_->Body == i && obj_->Type == _NURBSC && obj_->Num == j){
						flag = true;
						break;
					}
				}
				// ܂IĂȂ
				if(flag == false){
					SetNewObject(i,_NURBSC,j);
				}
			}

			// _TRIMMED_SURFACEIς݂ɂ鑀
			for(int j=0;j<body->TypeNum[_TRIMMED_SURFACE];j++){
				// ݒڒ̗vfɑIς݂𔻕
				bool flag = false;
				for(int k=0;k<SeldEntList.getNum();k++){
					OBJECT *obj_ = (OBJECT *)SeldEntList.getData(k);
					if(obj_ != NULL && obj_->Body == i && obj_->Type == _TRIMMED_SURFACE && obj_->Num == j){
						flag = true;
						break;
					}
				}
				// ܂IĂȂ
				if(flag == false)
					SetNewObject(i,_TRIMMED_SURFACE,j);
			}
			// _NURBSSIς݂ɂ鑀
			for(int j=0;j<body->TypeNum[_NURBSS];j++){
				bool flag = false;
				// ghȖʂƂđIς݂̏ꍇ͉Ȃ
				for(int k=0;k<body->TypeNum[_TRIMMED_SURFACE];k++){
					if(body->TrmS[j].pts == &body->NurbsS[k]){
						flag = true;
						break;
					}
				}
				// ghȖʂłȂꍇ́AɑIς݂𒲂ׂ
				if(flag == false){
					for(int k=0;k<SeldEntList.getNum();k++){
						OBJECT *obj_ = (OBJECT *)SeldEntList.getData(k);
						if(obj_ != NULL && obj_->Body == i && obj_->Type == _NURBSS && obj_->Num == j){
							flag = true;
							break;
						}
					}
				}
				// ܂IĂȂ
				if(flag == false)
					SetNewObject(i,_NURBSS,j);
			}
		}
	}

	ReDrawBODYFlag = KOD_FALSE;		// `惁XgĐݒ
}

// ZNVLZ
void KODatUNO::SelectionCancel()
{
	BODY *body;
	OBJECT *obj;

	for(int i=0;i<SeldEntList.getNum();i++){
		obj = (OBJECT *)SeldEntList.getData(i);
		body = SearchBodyList(&BodyList,obj->Body);			// ZNVĂGeBeBBODYԍ𒲂ׂ
		if (body == NULL) continue;							// DeleteBodyŏĂꍇ
		if(obj->Type == _NURBSC){
			InitCurveColor(body->NurbsC[obj->Num].Dstat.Color);		// IߐFɖ߂
		}
		else if(obj->Type == _TRIMMED_SURFACE || obj->Type == _NURBSS){
			InitSurfaceColor(body->NurbsS[obj->Num].Dstat.Color);	// IߐFɖ߂
		}
	}
	ClearSeldEntList();				// ZNVXgNA
	InitCmdFlags();					// CmdptOSKOD_FALSEɏ
	ReDrawBODYFlag = KOD_FALSE;		// `惁XgĐݒ
}

// IuWFNg̑I𔻕
int KODatUNO::ObjSelect(GLuint SelectBuf[],int hits)
{
	int i;
	int ZdepthMin=0;
	double Zdepth[MAXSELECT];
	double depthbuf[MAXSELECT];
	double temp=0;

	// qbgSẴIuWFNg̃fvXl𓾂
	for(i=0;i<hits;i++){
		Zdepth[i] = ((((double)SelectBuf[i*(3+SelectBuf[0])+1]/0xFFFFFFFF)+((double)SelectBuf[i*(3+SelectBuf[0])+2]/0xFFFFFFFF))/2.0);	// fvXobt@̍őlƍŏl̒Ԃ̒l
		depthbuf[i] = Zdepth[i];				// fvXl̃\[gp̃obt@p
	}
	
	// qbgIuWFNg̒ŃfvXlŏ̂̂߂
	if(hits == 1)
		ZdepthMin = 0;
	else if(hits > 1)
		BubbleSort(depthbuf,hits);		// ou\[gɂfvXlŏ̂̂𓾂
	
	// fvXlŏ̂̂ꍇAʂDIɑI
	for(i=0;i<hits;i++){
		if(Zdepth[i] == depthbuf[0] && SelectBuf[i*(3+SelectBuf[0])+4] == _NURBSC){
			ZdepthMin = i;
			temp++;
			break;
		}
	}
	
	// qbgɐȂꍇ
	if(temp == 0){
		for(i=0;i<hits;i++){
			if(Zdepth[i] == depthbuf[0])
				ZdepthMin = i;
		}
	}

	return ZdepthMin;
}

// Xォ̎_ɐ؂ւ
void KODatUNO::ChangeViewX()
{
	StartQ = QFunc.QInit(1,0,0,0);		// ̉]p
	QFunc.QtoR(RotMx,StartQ);			// ̉]p
	TargetQ = QFunc.QMult(QFunc.QGenRot(PI/2,0,0,1), StartQ);	// NH[^jIŏʒuɑ΂Z90]
	QFunc.QtoR(RotMx,TargetQ);			// ]sɑ
	StartQ = QFunc.QCopy(TargetQ);
	Trl[0] = Trl[1] = Trl[2] = 0;		// sړ̓Zbg
}

// Yォ̎_ɐ؂ւ
void KODatUNO::ChangeViewY()
{
	StartQ = QFunc.QInit(1,0,0,0);
	QFunc.QtoR(RotMx,StartQ);
	Trl[0] = Trl[1] = Trl[2] = 0;
}

// Zォ̎_ɐ؂ւ
void KODatUNO::ChangeViewZ()
{
	StartQ = QFunc.QInit(1,0,0,0);
	QFunc.QtoR(RotMx,StartQ);
	TargetQ = QFunc.QMult(QFunc.QGenRot(PI/2,1,0,0), StartQ);	// NH[^jIŏʒuɑ΂X90]
	QFunc.QtoR(RotMx,TargetQ);	
	StartQ = QFunc.QCopy(TargetQ);
	Trl[0] = Trl[1] = Trl[2] = 0;		// sړ̓Zbg
}

// Վ_ɐ؂ւ
void KODatUNO::ChangeViewXYZ()
{
	StartQ = QFunc.QInit(1,0,0,0);
	QFunc.QtoR(RotMx,StartQ);
	TargetQ = QFunc.QMult(QFunc.QGenRot(PI/6,0,0,1), StartQ);		// Z30
	TargetQ = QFunc.QMult(QFunc.QGenRot(-PI/10,1,0,0), TargetQ);	// X18
	QFunc.QtoR(RotMx,TargetQ);	
	StartQ = QFunc.QCopy(TargetQ);
	Trl[0] = Trl[1] = Trl[2] = 0;		// sړ̓Zbg
}

// CtrlL[{L[ꂽꍇBODY]
WSCbool KODatUNO::ChangeViewUp()
{
	if(!WSGIappKeyboard()->withCntl())	return True;	// CtrlL[ĂȂꍇ͉Ȃ

	Quat dq = QFunc.QGenRot(PI/12,1,0,0);				// ]NH[^jI
	TargetQ = QFunc.QMult(dq, StartQ);					// ]̏lStartQdq|ĉ]
	QFunc.QtoR(RotMx, TargetQ);							// NH[^jI]̕ϊs߂
	StartQ = QFunc.QCopy(TargetQ);						// XV
	Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w

	return False;
}

// CtrlL[{L[ꂽꍇBODY]
WSCbool KODatUNO::ChangeViewDown()
{
	if(!WSGIappKeyboard()->withCntl())	return True;	// CtrlL[ĂȂꍇ͉Ȃ

	Quat dq = QFunc.QGenRot(PI/12,-1,0,0);				// ]NH[^jI
	TargetQ = QFunc.QMult(dq, StartQ);					// ]̏lStartQdq|ĉ]
	QFunc.QtoR(RotMx, TargetQ);							// NH[^jI]̕ϊs߂
	StartQ = QFunc.QCopy(TargetQ);						// XV
	Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w

	return False;
}


// CtrlL[{L[ꂽꍇBODY]
WSCbool KODatUNO::ChangeViewLeft()
{
	if(!WSGIappKeyboard()->withCntl())	return True;	// CtrlL[ĂȂꍇ͉Ȃ

	Quat dq = QFunc.QGenRot(PI/12,0,0,-1);				// ]NH[^jI
	TargetQ = QFunc.QMult(dq, StartQ);					// ]̏lStartQdq|ĉ]
	QFunc.QtoR(RotMx, TargetQ);							// NH[^jI]̕ϊs߂
	StartQ = QFunc.QCopy(TargetQ);						// XV
	Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w

	return False;
}


// CtrlL[{EL[ꂽꍇBODY]
WSCbool KODatUNO::ChangeViewRight()
{
	if(!WSGIappKeyboard()->withCntl())	return True;	// CtrlL[ĂȂꍇ͉Ȃ

	Quat dq = QFunc.QGenRot(PI/12,0,0,1);				// ]NH[^jI
	TargetQ = QFunc.QMult(dq, StartQ);					// ]̏lStartQdq|ĉ]
	QFunc.QtoR(RotMx, TargetQ);							// NH[^jI]̕ϊs߂
	StartQ = QFunc.QCopy(TargetQ);						// XV
	Describe_Form->execEventProc(WSEV_EXPOSE,NULL);		// ĕ`w

	return False;
}


// {ftHgɖ߂
void KODatUNO::FitView()
{
	ModelScale = ModelScale1st;
}

// BODY``Solid\ɕύX
void KODatUNO::SolidView()
{
	DrawBODYFlag = KOD_TRUE;		// BODY`tOON
	EdgeViewFlag = KOD_TRUE;		// GbW`tOON
	SolidViewFlag = KOD_TRUE;		// \bh`tOON
	WireFlameViewFlag = KOD_FALSE;	// C[t[`tOOFF

	ReDrawBODYFlag = KOD_FALSE;		// BODY`惁XgĐݒtOON
	OpenGLInitFlag = KOD_FALSE;		// OpenGLXe[^XĐݒtOON
}

// Edge\ɂ
void KODatUNO::NoEdgeView()
{
	DrawBODYFlag = KOD_TRUE;		// BODY`tOON
	EdgeViewFlag = KOD_FALSE;		// GbW`tOOFF
	SolidViewFlag = KOD_TRUE;		// \bh`tOON
	WireFlameViewFlag = KOD_FALSE;	// C[t[`tOOFF

	ReDrawBODYFlag = KOD_FALSE;		// BODY`惁XgĐݒtOON
	OpenGLInitFlag = KOD_FALSE;		// OpenGLXe[^XĐݒtOON
}

// BODY``WireFlame\ɕύX
void KODatUNO::WireFlameView()
{
	DrawBODYFlag = KOD_TRUE;		// BODY`tOON
	EdgeViewFlag = KOD_TRUE;		// GbW`tOON
	WireFlameViewFlag = KOD_TRUE;	// C[t[`tOON
	SolidViewFlag = KOD_FALSE;		// \bh`tOOFF

	ReDrawBODYFlag = KOD_FALSE;		// BODY`惁XgĐݒtOON
	OpenGLInitFlag = KOD_FALSE;		// OpenGLXe[^XĐݒ
}

// BODY\
void KODatUNO::VoidView()
{
	DrawBODYFlag = KOD_FALSE;		// BODY`tOOFF
	EdgeViewFlag = KOD_FALSE;		// GbW`tOON
	WireFlameViewFlag = KOD_FALSE;	// C[t[`tOOFF
	SolidViewFlag = KOD_FALSE;		// \bh`tOOFF
}

// BODY𔼓ɂ
void KODatUNO::ViewBlending()
{
	BlendViewFlag = KOD_TRUE - BlendViewFlag;
}

// ZNVXgyOBJECT̏
void KODatUNO::ClearSeldEntList()
{
	OBJECT *obj;
	int objnum = SeldEntList.getNum();

	for(int i=0;i<objnum;i++){
		obj = (OBJECT *)SeldEntList.getData(i);
		delete obj;
	}
	SeldEntList.clear();
}


// CmdptOSKOD_FALSEɏ
void KODatUNO::InitCmdFlags()
{
	UVWireFlameViewFlag = KOD_FALSE;
	CPViewFlag = KOD_FALSE;
}

// UserFuncs
void KODatUNO::ExecuteUserFuncMain(int val)
{
	for(int i=0;i<USERFUNCNUMMAX;i++){
		if(i == val){
			AddEntSymbolToObj();				// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
			User.ExecWSFunc(val);				// User֐Dialogsꍇ͂̊֐ʂčs
			ExecUserFuncFlag[i] = KOD_TRUE;
			return;
		}
	}

}

// UserCommands̍ĕ`Ăяo(OpenGL`惋[v)
void KODatUNO::ReDrawUserCommand()
{
	for(int i=0;i<USERCOMMANDNUM;i++){
		if(ExecUserCommandFlag[i] == KOD_TRUE){
			ExecUserCommandFlag[i] = KOD_DONE;
			glNewList(COMMAND_DRAW_USER_COMMAND+i,GL_COMPILE_AND_EXECUTE);		// User֐i[Xgɓo^
			User.Command(&BodyList,&SeldEntList,SeldEntList.getNum(),i+SYSCOMMANDNUM,argc,argv);	// UserR}hs
			glEndList();												// [Xgo^I
			ReDrawBODYFlag = KOD_FALSE;		// BODY`惁XgĐݒtOON
			Describe_Form->redraw();		// `̈ɍĕ`w
			OpenDelBtn();					// Del{^̕ύX
			return;
		}
	}

	// 쐬User֐̃[XgĂяo
	for(int i=0;i<USERCOMMANDNUM;i++){
		if(ExecUserCommandFlag[i] == KOD_DONE){			// User֐isς݃tOONȂ
			glCallList(COMMAND_DRAW_USER_COMMAND+i);			// User֐ĩ[XgĂяo(User֐iŌĂяoꂽOpenGL`s)
		}
	}
}

// UserFuncs̍ĕ`Ăяo(OpenGL`惋[v)
void KODatUNO::ReDrawUserFunc()
{
	for(int i=0;i<USERFUNCNUMMAX;i++){
		if(ExecUserFuncFlag[i] == KOD_TRUE){
			ExecUserFuncFlag[i]  = KOD_DONE;
			glNewList(COMMAND_DRAW_USER+i,GL_COMPILE_AND_EXECUTE);		// User֐i[Xgɓo^
			int (USER::*userfn)(BODYList *,OBJECTList *,int);	
			userfn = User.UserFunc[i];
			ExecUserFuncFlag[i] = (User.*userfn)(&BodyList,&SeldEntList,SeldEntList.getNum());		// User֐is()
			if(ExecUserFuncFlag[i]  != KOD_FALSE && ExecUserFuncFlag[i]  != KOD_ERR){
				ExecUserFuncFlag[i]  = KOD_DONE;
			}
			glEndList();												// [Xgo^I
			ReDrawBODYFlag = KOD_FALSE;	// BODY`惁XgĐݒtOON
			Describe_Form->redraw();		// `̈ɍĕ`w
			OpenDelBtn();					// Del{^̕ύX
			return;
		}
	}

	// 쐬User֐̃[XgĂяo
	for(int i=0;i<USERFUNCNUMMAX;i++){
		if(ExecUserFuncFlag[i] == KOD_DONE){			// User֐isς݃tOONȂ
			glCallList(COMMAND_DRAW_USER+i);			// User֐ĩ[XgĂяo(User֐iŌĂяoꂽOpenGL`s)
		}
	}

}

// UserStatus̐ݒ
void KODatUNO::AcceptUserStat(int mode,double prop[])
{
	User.SetUserStatus(mode,prop);	// _CAO̒lUserNXUserStat\̂Ɋi[
}

// UserFuncɂĕ`悳ꂽ摜
void KODatUNO::UserViewCanncel()
{
	for(int i=0;i<USERFUNCNUMMAX;i++)
		ExecUserFuncFlag[i] = KOD_FALSE;
	for(int i=0;i<USERCOMMANDNUM;i++)
		ExecUserCommandFlag[i] = KOD_FALSE;

	User.ExecdClear();	// UserNXExecdClear()Ăяo

	InitCmdFlags();
}


// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
int KODatUNO::AddEntSymbolToObj()
{
	OBJECT *obj;
	int Cnum = 0;
	int Snum = 0;

	for(int i=0;i<SeldEntList.getNum();i++){
		obj = (OBJECT *)SeldEntList.getData(i);
		if(obj->Type == _NURBSC){
			obj->CCount = Cnum;
			Cnum++;
		}
		else if(obj->Type == _TRIMMED_SURFACE || obj->Type == _NURBSS){
			obj->SCount = Snum;
			Snum++;
		}
		else{
			SetMessage("ERROR:Unsupported entity was detected.");
			return KOD_ERR;
		}
	}

	return KOD_TRUE;
}


// R\[̃R}hs
void KODatUNO::ExecCommand(char *allcmdline)
{
	argc = AnalCommandLine(allcmdline,argv);		// R}hC͂Aargc,argv𓾂
	if(argc == KOD_ERR)								// ͂ĂȂ
		return;

	int cmdno = SearchRegdCmdNum(CmdMap,argv[0]);	// R}h̓o^ԍ𒲂ׂ
	if(cmdno == KOD_ERR){
		SetMessage("No such command name!");
		return;
	}

	if(cmdno<SYSCOMMANDNUM)
		CmdMap[cmdno].Command(argc,argv);			// o^ԍ𔻕ʂAVXeR}hs

	else if(cmdno >= SYSCOMMANDNUM && cmdno < COMMANDNUMMAX)
		ExecUserCommandFlag[cmdno-SYSCOMMANDNUM] = KOD_TRUE;
		//User.Command(&BodyList,&SeldEntList,SeldEntList.getNum(),cmdno,argc,argv);

	Describe_Form->redraw();		// `̈ɍĕ`w
}

// UVp[^ŕꂽC[t[\
void KODatUNO::UVWireView()
{
	if(!BodyList.getNum())	return;

	BODY *body;
	OBJECT *obj;
	NURBSS *NurbsS;
	NURBS_Func NFunc;
	Coord p;
	glDisable(GL_LIGHTING);
	glLineWidth(1);
	glColor3f(0.5,0.5,0.5);

	for(int pnum=0;pnum<SeldEntList.getNum();pnum++){
		obj = (OBJECT *)SeldEntList.getData(pnum);
		body = (BODY *)BodyList.getData(obj->Body);
		if(obj->Type != _NURBSS && obj->Type != _TRIMMED_SURFACE)	continue;
		int num;
		if(body->NurbsS[0].TrmdSurfFlag == KOD_TRUE)
			num = body->TypeNum[_TRIMMED_SURFACE];
		else
			num = body->TypeNum[_NURBSS];
		for(int i=0;i<num;i++){
			if(body->NurbsS[0].TrmdSurfFlag == KOD_TRUE)
				NurbsS = body->TrmS[i].pts;
			else
				NurbsS = &body->NurbsS[i];
			double du = NurbsS->U[1] - NurbsS->U[0];
			double dv = NurbsS->V[1] - NurbsS->V[0];
			for(int j=0;j<11;j++){
				glBegin(GL_LINE_STRIP);
				for(int k=0;k<51;k++){		// vp[^C`
					p = NFunc.CalcNurbsSCoord(NurbsS,0.1*(double)j*du,0.02*(double)k*dv);
					glVertex3d(p.x,p.y,p.z);
				}
				glEnd();
				glBegin(GL_LINE_STRIP);
				for(int k=0;k<51;k++){		// up[^C`
					p = NFunc.CalcNurbsSCoord(NurbsS,0.02*(double)k*du,0.1*(double)j*dv);
					glVertex3d(p.x,p.y,p.z);
				}
				glEnd();
			}
		}
	}
	glEnable(GL_LIGHTING);
}

// fXP[Zbg
void KODatUNO::SetModelScale(double scale)
{
	if(scale == 0) return;
	ModelScale = scale;
}

// fXP[擾
void KODatUNO::GetModelScale()
{
	char mes[256];
	sprintf(mes,"%.6lf",ModelScale);
	SetConsoleCharNum(SetMessage(mes));
}

// gXlZbg
void KODatUNO::SetTolerance(double val)
{
	if (val == 0) return;

	Tolerance = val;
	ReDrawBODYFlag = KOD_FALSE;		// ĕ`w
	Describe_Form->redraw();
}

// gXl擾
void KODatUNO::GetTolerance()
{
	char mes[256];
	sprintf(mes,"%.6lf",Tolerance);
	SetConsoleCharNum(SetMessage(mes));	// gXl\AR\[XV
}

// BODY𕽍sړ
void KODatUNO::GetShiftBody(Coord d)
{
	if(!BodyList.getNum())	return;

	BODY *body;
	OBJECT *obj;	
	NURBS_Func NFunc;

	obj = (OBJECT *)SeldEntList.getData(0);
	body = (BODY *)BodyList.getData(obj->Body);
	ShiftBody(body,d);
	
	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾
}

// BODY]
void KODatUNO::GetRotateBody(Coord ax,double d)
{
	if(!BodyList.getNum())	return;

	BODY *body;
	OBJECT *obj;	
	NURBS_Func NFunc;

	obj = (OBJECT *)SeldEntList.getData(0);
	body = (BODY *)BodyList.getData(obj->Body);
	RotBody(body,ax,d);

	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾
}

// BODYg
void KODatUNO::ExpandBody(Coord r)
{
	NURBS_Func NFunc;
	OBJECT *obj;
	BODY *body;

	for(int i=0;i<SeldEntList.getNum();i++){					// ZNVĂSẴGeBeBɑ΂
		obj = (OBJECT *)SeldEntList.getData(i);					// ̃ZNVĂGeBeB𓾂
		body = SearchBodyList(&BodyList,obj->Body);				// BODY̎̂𓾂
		if(obj->Type == _NURBSC){								// GeBeBNURBSȐȂ
			NFunc.ChRatioNurbsC(&body->NurbsC[obj->Num],r);		// NURBSȐ̊g
		}
		else if(obj->Type == _NURBSS){
			NFunc.ChRatioNurbsS(&body->NurbsS[obj->Num],r);
		}
		else if(obj->Type == _TRIMMED_SURFACE){
			NFunc.ChRatioNurbsS(body->TrmS[obj->Num].pts,r);
		}
	}

	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾
}


// eT[tFX𐶐
int KODatUNO::GenSurface(Coord Axis,double Prop,int Flag)
{
	NURBS_Func NFunc;
	OBJECT *obj;
	BODY *body,*newbody;

	for(int i=0;i<SeldEntList.getNum();i++){										// ZNVĂSẴGeBeBɑ΂
		obj = (OBJECT *)SeldEntList.getData(i);										// ̃ZNVĂGeBeB𓾂
		if(obj->Type == _NURBSC){													// GeBeBNURBSȐȂ
			body = SearchBodyList(&BodyList,obj->Body);								// NURBSȐĂBODY̎̂𓾂
			newbody = new BODY;														// V]T[tFXpBODY[m
			Init_body(newbody);														// newbody
			newbody->NurbsS = (NURBSS *)malloc(sizeof(NURBSS));						// NURBSȖʂ1[m
			if(Flag == ROTSURF){
				if(NFunc.GenRotNurbsS(newbody->NurbsS,body->NurbsC[obj->Num],Axis,Prop) == KOD_ERR)	// ]T[tFX
					goto EXIT;
			}
			else if(Flag == SWEEPSURF){
				if(NFunc.GenSweepNurbsS(newbody->NurbsS,body->NurbsC[obj->Num],Axis,Prop) == KOD_ERR)	// XC[vT[tFX
					goto EXIT;
			}

			newbody->NurbsS[0].TrmdSurfFlag = KOD_FALSE;							// ĝȂPNURBSȖʂł邱Ƃ𖾎
			newbody->TypeNum[_NURBSS] = 1;											// NURBSȖʂ̐1ɂ
			ChangeStatColor(newbody->NurbsS[0].Dstat.Color,0.2,0.2,1.0,0.5);		// F
			BodyList.add((void *)newbody);											// Xgnewbodyo^
			Body_List_Win->addItem("NewBody");										// BodyXgEBhEɂnewbodyo^
			strcpy(newbody->Name,"NewBody");										// Ƃ肠newbody̖O"NewBody"ƂĂ
		}
	}
	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾

	return KOD_TRUE;

EXIT:
	free(newbody->NurbsS);
	delete newbody;
	return KOD_ERR;
}

// NURBSȐ𐶐
int KODatUNO::GenNurbsCurve(int Val,char *Fname,int M)
{
	if(M < 2){
		SetMessage("NURBS ERROR: Few Rank. You should set rank more than 2.");
		return KOD_ERR;
	}

	NURBS_Func NFunc;
	FILE *fp;
	char buf[256];
	Coord pt[CTLPNUMMAX];
	int ptnum=0;
	BODY *newbody;

	// t@CǍ
	if((fp = fopen(Fname,"r")) == NULL){
		SetMessage("KODATUNO ERROR: fail to open file");
		return KOD_ERR;
	}
	while(fgets(buf,sizeof(buf),fp) != NULL){
		if(buf[0] == '#' || buf[0] == '\n')	continue;
		sscanf(buf,"%lf,%lf,%lf",&pt[ptnum].x,&pt[ptnum].y,&pt[ptnum].z);
		ptnum++;
		if(ptnum == CTLPNUMMAX){
			sprintf(buf,"KODATUNO ERROR: Too many points.  Reduce point number to %d or fewer.",CTLPNUMMAX);
			SetMessage(buf);
			return KOD_ERR;
		}
	}
	fclose(fp);

	// NURBSȐ
	NURBSC nurb;
	switch(Val){
		case 1:
			NFunc.GenPolygonalLine(&nurb,pt,ptnum);	// ܂
			break;
		case 2:
			if(NFunc.GenInterpolatedNurbsC1(&nurb,pt,ptnum,M) != KOD_TRUE)	// _NURBSȐ
				goto EXIT;
			break;
		case 3:
			if(NFunc.GenApproximationNurbsC(&nurb,pt,ptnum,M) != KOD_TRUE)	// _ߎNURBSȐ
				goto EXIT;
			break;
		case 4:
			if(NFunc.GenInterpolatedNurbsC2(&nurb,pt,ptnum,M) != KOD_TRUE)	// _NURBSȐ
				goto EXIT;
			break;			
		case 5:
			if(NFunc.GenNurbsCfromCP(&nurb,pt,ptnum,M) != KOD_TRUE)				// Rg[|CgNURBSȐ𐶐
				goto EXIT;
			break;
		default:
			goto EXIT;
	}

	// o^
	newbody = new BODY;
	RegistNurbsCtoBody(&BodyList,newbody,nurb,"NewBody_C");	// VNURBSȐVBODYƂēo^
	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾
	OpenDelBtn();							// Del{^̕ύX

	return KOD_TRUE;

EXIT:
	return KOD_ERR;
}

// NURBSȖʂ𐶐
// 
// Val:Ȗʂ̎(1:܂ 2:_NURBSȖ)
// *Fname:t@C   M:K
int KODatUNO::GenNurbsSurface(int Val,char *Fname,int M)
{
	if(M < 2 && Val != 1){
		SetMessage("NURBS ERROR: Few Rank. You should set Rank more than 2.");
		return KOD_ERR;
	}

	NURBS_Func NFunc;
	FILE *fp;
	char buf[256];
	Coord **pt;
	int row,col;
	int flag=KOD_FALSE;
	int ptnum=0;
	int i=0,j=0;
	BODY *newbody;

	// t@CǍ
	if((fp = fopen(Fname,"r")) == NULL){
		SetMessage("KODATUNO ERROR: fail to open file");
		return KOD_ERR;
	}

	// t@C_̍W𓾂
	while(fgets(buf,sizeof(buf),fp) != NULL){
		if(buf[0] == '#' || buf[0] == '\n')	continue;
		if(!flag){
			sscanf(buf,"%d,%d",&row,&col);
			if((pt = NewCoord2(row,col)) == NULL){		// _i[̈̃[m
				SetMessage("KODATUNO ERROR: fail to allocate memory");
				return KOD_ERR;
			}
			flag = KOD_TRUE;
		}
		else{
			sscanf(buf,"%lf,%lf,%lf",&pt[i][j].x,&pt[i][j].y,&pt[i][j].z);
			j++;
			if(j == col){
				i++;
				j = 0;
			}
			ptnum++;
			if(ptnum > PTNUMMAX){
				sprintf(buf,"KODATUNO ERROR: Too many points (%d).  Reduce point number to %d or fewer.",ptnum,PTNUMMAX);
				SetMessage(buf);
				FreeCoord2(pt,col);
				return KOD_ERR;
			}
		}
	}
	fclose(fp);

	// NURBSȖʐ
	NURBSS nurb;
	switch(Val){
		case 1:
			NFunc.GenPolygonalSurface(&nurb,pt,row,col);	// ܂
			break;
		case 2:
			if(NFunc.GenInterpolatedNurbsS1(&nurb,pt,row,col,M,M) == KOD_ERR)	// _NURBSȖ
				goto EXIT;
			break;
		case 3:
			if(NFunc.GenApproximationNurbsS(&nurb,pt,row,col,M,M) == KOD_ERR)	// _NURBSȖ
				goto EXIT;
			break;
		case 5:
			if(NFunc.GenNurbsSfromCP(&nurb,pt,row,col,M,M) == KOD_ERR)	// Rg[|CgNURBSȖʂ𐶐
				goto EXIT;
			break;
		default:
			goto EXIT;
	}

	// o^
	newbody = new BODY;
	RegistNurbsStoBody(&BodyList,newbody,nurb,"NewBody_S");	// VNURBSȖʂVBODYƂēo^
	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾
	OpenDelBtn();							// Del{^̕ύX

	SetMaxCoord();			// 쐬BODY̍őCoordl𒲂ׂ
	SetModelScale();		// fXP[œK

	FreeCoord2(pt,row);
	return KOD_TRUE;

EXIT:
	FreeCoord2(pt,row);
	return KOD_ERR;
}

// R}ho^
void KODatUNO::SetConsoleHistory(WSCstring His)
{
	if(His == (WSCstring)"\n>")	return;		// R}hȂ

	CmdStackNow = 0;		// ݒڒ̗R}hԍ0ɏ

	// CmdStack[0]󂯂
	if(CmdStackNum){
		for(int i=CmdStackNum-1;i>=0;i--){
			if(CmdStackNum == HISTORYNUMMAX && i == CmdStackNum-1)	continue;
			sprintf(CmdStack[i+1],"%s",CmdStack[i]);
		}
	}

	// CmdStack[0]ɐVȃR}hL^
	His.cutString(His.getChars()-2);
	sprintf(CmdStack[0],"%s",(char *)His);

	if(CmdStackNum != HISTORYNUMMAX)
		CmdStackNum++;

}

// R}h擾(L[)
int KODatUNO::GetUpperConsoleHistory(WSCstring *cmd)
{
	if(!CmdStackNum)
		return KOD_FALSE;		// R}hȂ

	if(CmdStackNow == CmdStackNum)		// L[𗚗R}hȏɉꍇ͍ŏɖ߂
		CmdStackNow = 0;

	*cmd = (WSCstring)CmdStack[CmdStackNow];	// R}ho
	CmdStackNow++;				// R}hԍCNg
	return KOD_TRUE;
}

// R}h擾(L[)
int KODatUNO::GetLowerConsoleHistory(WSCstring *cmd)
{
	if(!CmdStackNum)
		return KOD_FALSE;

	CmdStackNow--;

	if(CmdStackNow <= 0)
		CmdStackNow = CmdStackNum;

	*cmd = (WSCstring)CmdStack[CmdStackNow-1];
	return KOD_TRUE;
}

// IĂȖʂ̃Rg[|Cg`
void KODatUNO::DescribeCP()
{
	if(!BodyList.getNum())	return;

	BODY *body;
	OBJECT *obj;
	double col[3] = {0,1,0};
	char buf[256];

	glDisable(GL_LIGHTING);

	for(int pnum=0;pnum<SeldEntList.getNum();pnum++){
		obj = (OBJECT *)SeldEntList.getData(pnum);
		body = (BODY *)BodyList.getData(obj->Body);
		//if(obj->Type == _NURBSC){
		//	DrawPoints(body->NurbsC[obj->Num].cp,body->NurbsC[obj->Num].K,1,3,col);
		//}
		if(obj->Type == _NURBSS){
			for(int i=0;i<body->NurbsS[obj->Num].K[0];i++){
				for(int j=0;j<body->NurbsS[obj->Num].K[1];j++){
					DrawPoint(body->NurbsS[obj->Num].cp[i][j],1,3,col);
				}
			}
		}
		else if(obj->Type == _TRIMMED_SURFACE){
			for(int i=0;i<body->TrmS[obj->Num].pts->K[0];i++){
				for(int j=0;j<body->TrmS[obj->Num].pts->K[1];j++){
					DrawPoint(body->TrmS[obj->Num].pts->cp[i][j],1,3,col);
				}
			}
		}
	}

	glEnable(GL_LIGHTING);
}

// IĂȖʂ̏R\[o͂
void KODatUNO::GetSurfInfo()
{
	if(!BodyList.getNum())	return;

	BODY *body;
	OBJECT *obj;
	NURBSS *ns;
	char buf[256];

	for(int pnum=0;pnum<SeldEntList.getNum();pnum++){
		obj = (OBJECT *)SeldEntList.getData(pnum);
		body = (BODY *)BodyList.getData(obj->Body);
		if(obj->Type == _NURBSS){
			ns=&body->NurbsS[obj->Num];
			sprintf(buf,"NURBS Surface");
			SetMessage(buf);
		}
		else if(obj->Type == _TRIMMED_SURFACE){
			ns=body->TrmS[obj->Num].pts;
			sprintf(buf,"TRIMED Surface");
			SetMessage(buf);
		}
		sprintf(buf,"No. of CP: %d x %d = %d",ns->K[0],ns->K[1],ns->K[0]*ns->K[1]);
		SetMessage(buf);
		sprintf(buf,"Rank: %d, %d",ns->M[0],ns->M[1]);
		SetMessage(buf);
		sprintf(buf,"No. of Knot [Range]: %d[%.3lf - %.3lf], %d[%.3lf - %.3lf]",ns->N[0],ns->U[0],ns->U[1],ns->N[1],ns->V[0],ns->V[1]);
		SetMessage(buf);
	}
}

// IĂȖʂRankύX
void KODatUNO::ChangeRank(int Newrank[2])
{
	if(!BodyList.getNum())	return;

	char buf[256];

	if(Newrank[0] < 2 || Newrank[1] < 2){
		sprintf(buf,"ERROR:Specified few rank");
		SetMessage(buf);
		return;
	}

	NURBS_Func NFunc;
	BODY *body;
	OBJECT *obj;
	NURBSS *ns;

	for(int pnum=0;pnum<SeldEntList.getNum();pnum++){
		obj = (OBJECT *)SeldEntList.getData(pnum);
		body = (BODY *)BodyList.getData(obj->Body);
		if(obj->Type == _NURBSS){
			ns=&body->NurbsS[obj->Num];
		}
		else if(obj->Type == _TRIMMED_SURFACE){
			ns=body->TrmS[obj->Num].pts;
		}
		else
			continue;

		// rankRg[|Cg傫ꍇ̓G[
		if(Newrank[0] > ns->K[0] || Newrank[1] > ns->K[1]){
			sprintf(buf,"ERROR:Specified rank exceeds number of control points");
			SetMessage(buf);
			return;
		}
		int oldrank[2];
		oldrank[0] = ns->M[0];		// ܂łrankۑĂ
		oldrank[1] = ns->M[1];
		ns->M[0] = Newrank[0];		// Vranko^
		ns->M[1] = Newrank[1];
		ns->N[0] = ns->K[0] + ns->M[0];	// mbg̐Ďw
		ns->N[1] = ns->K[1] + ns->M[1];

		// Newrankoldrank傫ꍇ̓mbgxNgzĊm
		double *tmp1,*tmp2;
		bool flag = false;
		if(Newrank[0] > oldrank[0]){
			if((tmp1 = (double *)realloc(ns->S,sizeof(double)*ns->N[0])) == NULL){
				goto EXIT;
			}
			ns->S = tmp1;
			flag = true;
		}
		if(Newrank[1] > oldrank[1]){
			if((tmp2 = (double *)realloc(ns->T,sizeof(double)*ns->N[1])) == NULL){
				goto EXIT;
			}
			ns->T = tmp2;
			flag = true;
		}

		NFunc.GetEqIntervalKont(ns->K[0],ns->M[0],ns->S);	// mbgxNgĐݒ
		NFunc.GetEqIntervalKont(ns->K[1],ns->M[1],ns->T);
		ns->U[0] = ns->V[0] = 0;		// mbgxNg͈̔͂w
		ns->U[1] = ns->V[1] = NORM_KNOT_VAL;		
	}

	DrawBODYFlag = KOD_TRUE;				// BODY`悵ĂOKtOON
	ReDrawBODYFlag = KOD_FALSE;				// BODỸXgĎ擾
	return;

EXIT:			
	sprintf(buf,"ERROR:Fail to malloc");
	SetMessage(buf);
}

