// KodatunõC^[tF[X֌W`

#ifndef _KODATUNO_H_
#define _KODATUNO_H_


#include "IGES_Parser.h"
#include "STL_Parser.h"
#include "StdAfx.h"
#include "Quaternion.h"
#include "Describe_BODY.h"
#include "UserFunc.h"
#include "Command.h"

#define EXT_IGES	1						// gqʗp(IGES)
#define EXT_STL		2						// gqʗp(STL)
#define CONSOLE_CHAR_NUMMAX	2048			// R\[ɓ͂ł镶̍ől
#define MAXSELECT	20000					// ZNV̍őobt@TCY
#define BODYLISTMAX	8						// ǂݍ߂BODY̍ő吔
#define TOLERANCE 20						// NURBSȖʂ̑ẽftHgl
#define HISTORYNUMMAX 10					// R}h

// NURBSȖʂ̐@\V{
#define ROTSURF	0							// ]T[tFX		
#define SWEEPSURF 1							// XC[vT[tFX


// KODatUNONX`
class KODatUNO : public BODY_Handler		// BODY֘A֐W߂NXp
{
// public֐̒`
public:
	void InitializeWin();					// Kodatunȍ
	void DeleteWin();						// KodatunȍI
	int OpenFile();							// t@CI[v
	int OpenFile(char *);					// t@CI[v(I[o[[h)
	int OpenInpFile();						// Cvbgt@CI[v
	int BodyListSelect();					// {fBXgI
	void ReDraw(int,int);					// ĕ`
	void ReDrawUserFunc();					// UserFuncs̍ĕ`Ăяo
	void ReDrawUserCommand();				// UserCommands̍ĕ`Ăяo
	int GetConsoleCharNum();				// R\[o
	void SetConsoleCharNum(int);			// R\[ۑ
	void ExecCommand(char *);				// R}hs
	int GetUpperConsoleHistory(WSCstring *);	// R}h擾
	int GetLowerConsoleHistory(WSCstring *);	// R}h擾
	void SetConsoleHistory(WSCstring);		// R}ho^
	void GetResizeWindow();					// EBhETCYꂽƂɁÃEChETCYǂݍ
	void MouseEvent(long,long,short,short);	// }EXCxg̏
	void MouseMotionEvent(long,short,short);// }EXړ̃Cxg
	void ChangeViewX();						// X̎_ɐ؂ւ
	void ChangeViewY();						// Y̎_ɐ؂ւ
	void ChangeViewZ();						// Z̎_ɐ؂ւ
	void ChangeViewXYZ();					// Վ_ɐ؂ւ
	WSCbool ChangeViewUp();					// L[ꂽꍇBODY]
	WSCbool ChangeViewDown();					// L[ꂽꍇBODY]
	WSCbool ChangeViewLeft();					// L[ꂽꍇBODY]
	WSCbool ChangeViewRight();					// EL[ꂽꍇBODY]
	void FitView();							// {ftHgɖ߂
	void SolidView();						// Solid\
	void NoEdgeView();						// Edge\ɂ
	void WireFlameView();					// WireFlame\
	void VoidView();						// \Ȃ
	void SelectAll();						// SăZNgԂɂ
	void SelectionCancel();					// ZNVLZ
	void ViewBlending();					// BODY𔼓\
	void DeleteBody();						// BODY
	void OpenDelBtn();						// OpenCDelete{^̕\̕ύX
	void ExecuteUserFuncMain(int);			// UserFunc̎s
	void AcceptUserStat(int,double []);		// UserStatus̐ݒ
	void UserViewCanncel();					// UserFuncɂĕ`悳ꂽ摜
	void SetModelScale(double);				// fXP[Zbg
	void GetModelScale();					// fXP[l擾
	void SetTolerance(double);				// gXlZbg
	void GetTolerance();					// gXl擾
	void GetShiftBody(Coord);				// BODY𕽍sړ
	void GetRotateBody(Coord,double);		// BODY]
	void ExpandBody(Coord);					// BODYg
	int GenSurface(Coord,double,int);		// eT[tFX𐶐
	int GenNurbsCurve(int,char *,int);		// w肵t@Cǂݍ,NURBSȐ𐶐
	int GenNurbsSurface(int,char *,int);	// w肵t@Cǂݍ,NURBSȖʂ𐶐
	void GetSurfInfo();						// IĂȖʂ̏R\[o͂
	void ChangeRank(int []);				// IĂȖʂRankύX

// private֐̒`
private:
	void Describe_Main();				// BODY`
	void DrawBODY();					// BODY`̃C
	void DrawAxis(double,double);		// ̕`
	void DrawRubberband(double,double,double,double);	// o[oh̕`
	void Draw_NurbsCurve(BODY *);		// NURBSȐ`
	void Draw_NurbsSurface(BODY *);		// NURBSȐ`
	void Draw_TrimSurfe(BODY *);		// gʂ`
	void UVWireView();					// UVp[^ŕꂽC[t[\
	void SetOpenGLStat();				// OpenGL̏
	void SetModelScale();				// `掞̃XP[
	void SetMaxCoord();					// Body̍ő咷ݒ肷
	void DoSelect(int,int);				// ZNV(}EXsbLO)
	void ClearSeldEntList();			// ZNVXgyOBJECT̏
	void DeleteBodySub(BODY *,int);		// BODYSUB
	void ClickPicking(GLuint SelectBuf[],int hits);	// IuWFNg̃}EXsbLO(NbN)
	void DragPicking(GLuint SelectBuf[],int hits);	// IuWFNg̃}EXsbLO(hbO)
	int  ObjSelect(GLuint [],int);					// IuWFNgI𔻕
	int AddEntSymbolToObj();			// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
	void InitCmdFlags();				// CmdptOSKOD_FALSEɏ
	void SetNewObject(int,int,int);		// sbNꂽIuWFNgOBJECTXgɓo^
	void DescribeCP();						// Rg[|Cg`


// pbulicϐ̒`
public:
	int  UVWireFlameViewFlag;	// UVC[t[\tO
	int  CPViewFlag;			// Rg[|Cg`tO

// privateϐ̒`
private:
	USER User;					// [U[NX
	BODYList	BodyList;		// BODYXg̑pCX^X
	OBJECTList SeldEntList;		// ZNVꂽGeBeB𒀎i[ĂXg
	CommandMap CmdMap[COMMANDNUMMAX];		// R}h}bv
	int	ConsoleCharNum;			// R\[ɓ͂ĂSĂ̕ێ
	int Focus_Body;				// I𒆂Body\l
	QUATERNION QFunc;			// NH[^jĨCX^X
	double RotMx[TMATELEMNUM];	// NH[^jIϊ}gbNX
	Quat StartQ;				// ENbNuԂ̉]pi[NH[^jI
	Quat TargetQ;				// 肮Ăr̃NH[^jI
	double ModelScale;			// ݂̃fXP[
	double ModelScale1st;		// fXP[̏l
	double Tolerance;			// NURBS\鎞̖ʂ̑e
	double Trl[3];				// sړ
	int  Vp[4];					// r[|Cg
	double AxisScale;			// `̃XP[
	int  OpenGLInitFlag;		// OpenGLݒς݃tO
	int  ExecUserFuncFlag[USERFUNCNUMMAX];	// UserFunc`tO
	int  ExecUserCommandFlag[USERCOMMANDNUM];	// UserCommand`tO
	int  DoSelectFlag;			// ZNVstO
	int  SweepSelectFlag;		// XC[vZNVJnƂtO
	int  ScreenHeight;			// ftHgXN[̍
	int  ScreenWidth;			// ftHgXN[̕
	int  StartX;				// hbOJnʒuX
	int  StartY;				// hbOJnʒuY
	int  OldPosX;				// EBhEĕ`撼OXW
	int  OldPosY;				// EBhEĕ`撼OYW
	int  CurrentX;				// hbÖʒuX
	int  CurrentY;				// hbÖʒuY
	int  LBtnFlag;				// NbNƂtO
	int  RBtnFlag;				// ENbNƂtO
	int  MBtnFlag;				// NbNƂtO
	int  ShiftKeyFlag;			// ShiftL[ƂtO
	int  CtrlKeyFlag;			// CtrlL[ƂtO
	int  AltKeyFlag;			// AltL[ƂtO
	int  SolidViewFlag;			// \bh\tO
	int  EdgeViewFlag;			// GbW\tO
	int  WireFlameViewFlag;		// C[t[\tO
	int  BlendViewFlag;			// \tO
	int  DrawBODYFlag;			// BODY`tO
	int  DrawSurfFlag;			// Surface`tO
	int	 ReDrawBODYFlag;		// BODY`1ڂtO
	GLuint SelectBuf[MAXSELECT];	// ZNgobt@
	int argc;						// R}h
	char *argv[MAXCOMMANDOPNUM];	// R}h
	char CmdStack[HISTORYNUMMAX][256];	// R}h
	int CmdStackNum;				// R}h
	int CmdStackNow;

};

// KodatunoNX̃O[o錾
extern KODatUNO	Kodatuno;

// KodatunoVXeR}ho^
void CmdVerInf(int,char *[]);			// R}h(o[Wo)
void CmdFileOpen(int,char *[]);			// R}h(t@CI[v)
void CmdUVWire(int,char *[]);			// R}h(UVC[t[\)
void CmdChScale(int,char *[]);			// R}h(XP[ύX)
void CmdGenRotSurf(int,char *[]);		// R}h(]T[tFX)
void CmdGenSweepSurf(int,char *[]);		// R}h(XC[vT[tFX)
void CmdGenNurbsCurve(int,char *[]);	// R}h(NurbsȐ)
void CmdGenNurbsSurface(int,char *[]);	// R}h(NurbsȖʐ)
void CmdChTolerance(int,char *[]);		// R}h(gXύX)
void CmdMoveBody(int,char *[]);			// R}h(BODY̕sړ)
void CmdRotateBody(int ,char *[]);		// R}h(BODỶ])
void CmdCPView(int ,char *[]);			// R}h(Rg[|Cg`)
void CmdSurfInfo(int,char *[]);			// R}h(Ȗʏo)
void CmdExpand(int,char *[]);			// R}h(BODY̊g)
void CmdChRank(int,char *[]);			// R}h(NURBS Rnak̕ύX)
#endif
